"""
Copyright (C) 2009-2011 EdenWall Technologies

This file is part of NuFirewall. 
 
 NuFirewall is free software: you can redistribute it and/or modify 
 it under the terms of the GNU General Public License as published by 
 the Free Software Foundation, version 3 of the License. 
 
 NuFirewall is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 GNU General Public License for more details. 
 
 You should have received a copy of the GNU General Public License 
 along with NuFirewall.  If not, see <http://www.gnu.org/licenses/>
"""
from nucentral.common import tr

SUPPORTED_VERSIONS = ("1.0",)

class Compatibility:
    def __init__(self, parent):
        self.parent = parent
        self.client = parent.client
        self.getVersions()
        self.getFeatures()

    def getVersions(self):
        self.server_version = self.client.call('audit', 'getVersion')

    def getFeatures(self):
#        if self.server_version == "2.0":
#            pass
        if self.server_version not in SUPPORTED_VERSIONS:
            warning = \
                tr("Warning: The server (%s) is more recent "
                   "than the client. "
                   "Please upgrade your client.") \
                % self.client.host
        elif self.server_version != self.parent.CLIENT_VERSION:
            warning = \
                tr("Warning: The server (%s) is older than "
                   "your client: disabling some features. "
                   "Please upgrade your server.") \
                % self.client.host
        else:
            warning = None

        if warning:
            self.parent.error(warning)