from PyQt4.QtGui import QDialog
from PyQt4.QtCore import SIGNAL, QTime

from console_edenwall.ui.option_audit_ui import Ui_OptionDialog

class OptionDialog(QDialog):

    def __init__(self, parent = None):
        QDialog.__init__(self, parent)
        self.ui = Ui_OptionDialog()
        self.ui.setupUi(self)
        self._parameters = None

        self.connect(self.ui.pb_cancel, SIGNAL("clicked()"), self.close)

    def getButtonOk(self):
        return self.ui.pb_ok
    def getSpinSource(self):
        return self.ui.sb_source_threshold
    def getSpinCategory(self):
        return self.ui.sb_category_threshold
    def getSpinEvent(self):
        return self.ui.sb_max_events
    def getCheckBNotice(self):
        return self.ui.cb_notice
    def getSpinThresholdCombination(self):
        return self.ui.sb_threshold_comb
    def getThresholdTime(self):
        return self.ui.te_time

    def setParameters(self, parameters):
        self._parameters = parameters
        self.ui.sb_source_threshold.setValue(self._parameters['source_threshold'])
        self.ui.sb_category_threshold.setValue(self._parameters['category_threshold'])
        self.ui.sb_max_events.setValue(self._parameters['max_stored_events'])
        self.ui.cb_notice.setChecked(self._parameters['additional_action_enabled'])

        self.ui.sb_threshold_comb.setValue(self._parameters['combination_threshold'])
        self.ui.te_time.setTime(QTime().addSecs((self._parameters['combination_time'])))

    pb_ok = property(fget=getButtonOk)
    sb_source_threshold = property(fget=getSpinSource)
    sb_category_threshold = property(fget=getSpinCategory)
    sb_max_events = property(fget=getSpinEvent)
    cb_notice = property(fget=getCheckBNotice)
    sb_threshold_comb = property(fget=getSpinThresholdCombination)
    te_time = property(fget=getThresholdTime)
    parameters = property(fset=setParameters)
