from PyQt4.QtGui import QLabel
from PyQt4.QtGui import QPixmap

from nucentral.common import tr

class StatusBarModifiedWidget(QLabel):

    def __init__(self, parent=None):
        QLabel.__init__(self, parent)
        self.setNotModified()

    def setModified(self):
        self.setPixmap( QPixmap(":/icons-20/warning.png") )
        self.setToolTip( tr("There are unsaved changes") )

    def setNotModified(self):
        self.setPixmap( QPixmap(":/icons-20/status_on.png") )
        self.setToolTip( tr("Changes saved") )

    def setModifiedState(self, state):
        if state:
            self.setModified()
        else:
            self.setNotModified()


class StatusBarTextWidget(QLabel):

    def __init__(self, parent=None):
        QLabel.__init__(self, parent)
        self.hide()

    def setTextWithColor(self, text, color=None):
        QLabel.setText(self,text)
        css = "padding-left: 4px; padding-right: 4px;"
        if color:
            color += " background-color: %s;" % color
        self.setStyleSheet(css)
        self.show()

