#!/usr/bin/env python
from sys import argv

CLASSIFIERS = [
    'Intended Audience :: Developers',
    'Development Status :: 4 - Beta',
    'License :: Unknown',
    'Operating System :: OS Independent',
    'Natural Language :: English',
    'Programming Language :: Python',
]

PACKAGES = ('console_edenwall', 'console_edenwall.ui')

def main():
    if "--setuptools" in argv:
        argv.remove("--setuptools")
        from setuptools import setup
        use_setuptools = True
    else:
        from distutils.core import setup
        use_setuptools = False

    long_description = "NuFirewall Administration Suite"

    install_options = {
        "name": "nufirewall-administration-suite",
        "version": "4.0",
        "url": "http://www.nufirewall.org",
        "download_url": "",
        "license": "License",
        "author": "EdenWall Technologies",
        "description": long_description,
        "long_description": long_description,
        "classifiers": CLASSIFIERS,
        "packages": PACKAGES,
        "scripts": ("nufirewall-administration-suite",),
    }
    if use_setuptools:
        install_options["install_requires"] = ["PyQt4>=4.4"]
    setup(**install_options)

if __name__ == "__main__":
    main()

