
class SNMPObject:

    def get_value(self, oid):
        #return [oid,"integer",666]
        return None

class SNMPTreeNode:

    def __init__(self, name, index):
        self.childs = { }
        self.keys = [ ]
        self.name = name
        self.index = index
        self.type = None
        self.val = None

    def set_simple_value(self, type, val):
        self.type = type
        self.val = val

    def addChild(self, child):
        if not isinstance(child,SNMPTreeNode):
            raise Exception("child must be an instance of SNMPTreeNode")
        if not isinstance(child.index,int):
            raise Exception("index must be an integer")
        self.childs[child.index] = child
        # rebuild the sorted list of keys
        self.keys = self.childs.keys()
        self.keys.sort()

    def walk(self, current_index, cb):
        current_index = current_index + "." + str(self.index)
        cb(current_index,self)
        for child in self.keys:
            c = self.childs[child]
            c.walk(current_index, cb)

    def get(self, oid, oid_list):
        #print "%s(%d).get %s" % (self.name,self.index,oid)
        #print "\t",oid_list
        if oid_list[0] != self.index:
            # not for me !
            return None
        # are we a leaf ?
        if len(oid_list) == 1:
            return self.get_value(oid)
        # does the required OID exist ?
        if not oid_list[1] in self.keys:
            return None
        c = self.childs[oid_list[1]]
        return c.get(oid, oid_list[1:])

    def getnext(self, oid, oid_list):
        t = self.get(oid, oid_list)
        if not t:
            return None
        nextoid = self.getnextoid(oid, oid_list)
        t[0] = nextoid
        return t

    def getnextoid(self, oid, oid_list, current_oid=".1"):
        #print "%s(%d).getnextoid %s (current: %s)" % (self.name,self.index,oid, current_oid)
        #print "\t",oid_list
        # is this the end ?
        if oid_list[0] != self.index:
            # not for me !
            #print "not for me !"
            return None
        # first of all, is the request for a child ?
        if len(oid_list)>1:
            # check that child exists
            if not oid_list[1] in self.keys:
                # getnext on a non-existing entry
                #print "getnext on a non-existing entry"
                return None
            # then ask child
            wanted_oid = oid_list[1]
            c = self.childs[wanted_oid]
            ret = c.getnextoid(oid, oid_list[1:], current_oid + "." + str(wanted_oid))
            # if the child has found next oid, believe it
            if ret:
                #print "child: ", ret
                return ret
            else:
                # child does not know the next oid.
                # check if we know it directly
                idx = self.keys.index(wanted_oid)
                if len(self.keys) > idx+1:
                    #print "found: ", current_oid + "." + str(self.keys[idx+1])
                    return current_oid + "." + str(self.keys[idx+1])
                #print "last element, returning None"
                return None
        else:
            #print "list has size ", len(oid_list)
            if len(self.keys)>0:
                #print "found new child: ", current_oid + "." + str(self.keys[0])
                return current_oid + "." + str(self.keys[0])
            return None

    def get_value(self, oid):
        #return [oid,"integer",666]
        if not self.type:
            return [oid, "string", "object"]
            #return None
        else:
            return [oid, self.type, self.val]

