"""
Copyright 2010 EdenWall Technologies

Written by Pierre Chifflier <chifflier@edenwall.com>
"""

import time

from .log import setmeupaslogger

class NNDCache(object):

    def __init__(self,  logger, expire_time=30):
        self.cache = dict()
        self.expire_time = expire_time
        setmeupaslogger(self, logger)

    def __getitem__(self, key):
        # test cache expiry
        try:
            val = self.cache[key]
            if val[0] < time.time() - self.expire_time:
                # invalidate cache entry
                self.debug("CACHE got entry, but expired")
                del self.cache[key]
                return None
            # cache hit
            self.debug("CACHE hit")
            return val[1]
        except KeyError:
            # cache miss
            self.debug("CACHE miss")
            return None
        return None

    def __setitem__(self,  key,  val):
        self.cache[key] = [time.time(),  val]
        return val
