import socket

from .error import NNDError

def socketinfo(conn):
    if conn.family == socket.AF_UNIX:
        return "bound to unix socket: %s" % conn.getsockname()
    return "connected from %s." % conn.getpeername()

def shortsockinfo(conn):
    if conn.family == socket.AF_UNIX:
        return conn.getsockname()
    return conn.getpeername()

def formatsockerror(conn, err):
    return "sock error (client %s): %s" % (socketinfo(conn), err)

def accept_username(username):
    return not (
        "," in username
        or "\n" in username
        )

def accept_groupname(groupname):
    return not (
        "," in groupname
        or "\n" in groupname
        or '@' in groupname
        )

def checkonesubst(ldapfilter, errorlocator):
    try:
        ldapfilter % "dummy"
    except TypeError:
        raise NNDError(
            "Invalid configuration in [%s]: filter '%s' should "
            "contain %%s exactly once" % (errorlocator, ldapfilter)
            )

