#!/usr/bin/env python
from imp import load_source
from os import path

def main():
    from distutils.core import setup

    nnd_daemon = load_source("version", path.join("nnd", "server", "version.py"))

    long_description = open('README').read().strip()

    setup(
        name=nnd_daemon.PACKAGE,
        version=nnd_daemon.VERSION,
        url=nnd_daemon.WEBSITE,
        download_url=nnd_daemon.WEBSITE,
        license=nnd_daemon.LICENSE,
        long_description=long_description,
        author="Pierre Chifflier",
        description="NuFW NSS daemon",
        packages=(
            "nnd",
            "nnd.client",
            "nnd.daemon",
            "nnd.daemon.version",
            "nnd.server",
            "nnd.qt",
        ),
        scripts=("nufw-nss-daemon",),
    )

if __name__ == "__main__":
    main()

