#!/bin/sh
# $Id$
set -x
# Overwrite ipsec.secrets if it exists and do not fail if it does not.

IPSEC_SECRETS="/etc/ipsec.secrets"

insert_private_key() {
    cat <<EOF > "${IPSEC_SECRETS}"
: RSA   {
$1
        }
EOF
}

rm -f ${IPSEC_SECRETS}
keylength=2048
privkey=`mktemp /tmp/ipsec-postinst.XXXXXX`
/usr/lib/ipsec/rsasigkey ${keylength} > "${privkey}"
insert_private_key "`cat "${privkey}"`"
rm "${privkey}"

# include keys generated by site2site component
echo "include /etc/ipsec.d/private/keys.conf" >> "${IPSEC_SECRETS}"
chmod 0644 "${IPSEC_SECRETS}"

