#!/usr/bin/env python
# -*- coding: utf-8 -*-

"""
Copyright (C) 2009-2011 EdenWall Technologies

This file is part of NuFirewall. 
 
 NuFirewall is free software: you can redistribute it and/or modify 
 it under the terms of the GNU General Public License as published by 
 the Free Software Foundation, version 3 of the License. 
 
 NuFirewall is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 GNU General Public License for more details. 
 
 You should have received a copy of the GNU General Public License 
 along with NuFirewall.  If not, see <http://www.gnu.org/licenses/>
"""


from imp import load_source
from os import path
from sys import argv

CLASSIFIERS = [
    'Intended Audience :: Developers',
    'Development Status :: 4 - Beta',
    'License :: OSI Approved :: GNU General Public License (GPL)',
    'Operating System :: OS Independent',
    'Natural Language :: English',
    'Programming Language :: Python',
]

PACKAGES = (
    'nuconf.client.NuConfWidgets',
    'nuconf.client',
    'nuconf.client.qt',
    'nuconf.client.system',
    'nuconf.client.system.contact',
    'nuconf.client.system.ha',
    'nuconf.client.system.httpout',
    'nuconf.client.system.license',
    'nuconf.client.system.network',
    'nuconf.client.system.network.wizards',
    'nuconf.client.system.ntp',
    'nuconf.client.system.nuauth',
    'nuconf.client.system.resolv',
    'nuconf.client.system.syslog_export',
    'nuconf.client.system.tools',
    'nuconf.client.services',
    'nuconf.client.services.access',
    'nuconf.client.services.authentication',
    'nuconf.client.services.dhcp',
    'nuconf.client.services.dock_windows',
    'nuconf.client.services.ids_ips',
    'nuconf.client.services.mail',
    'nuconf.client.services.proxy',
    'nuconf.client.services.roadwarrior',
    'nuconf.client.services.site2site',
    'nuconf.client.services.snmpd',
)

def main():
    if "--setuptools" in argv:
        argv.remove("--setuptools")
        from setuptools import setup
        use_setuptools = True
    else:
        from distutils.core import setup
        use_setuptools = False

    nuconf = load_source("version", path.join("nuconf", "version.py"))

    long_description = open('README').read() + open('ChangeLog').read()

    install_options = {
        "name": nuconf.PACKAGE,
        "version": nuconf.VERSION,
        "url": nuconf.WEBSITE,
        "download_url": nuconf.WEBSITE,
        "license": nuconf.LICENSE,
        "author": "Francois Toussenel, Michael Scherrer, Feth AREZKI",
        "description": "System configuration backend and frontend",
        "long_description": long_description,
        "classifiers": CLASSIFIERS,
        "packages": PACKAGES,
        "scripts": ("nuconf-qt",),
    }
    if use_setuptools:
        install_options["install_requires"] = ["IPy>=0.42"]
    setup(**install_options)

if __name__ == "__main__":
    main()

