#!/usr/bin/env python
# -*- coding: utf-8 -*-
from os import path
from imp import load_source
import sys

if "--setuptools" in sys.argv:
    sys.argv.remove("--setuptools")
    from setuptools import setup
    use_setuptools = True
else:
    from distutils.core import setup
    use_setuptools = False

# Retrieve revision numbers
nuconntrack = load_source("version", path.join("nuconntrack", "version.py"))

DESCRIPTION = "nuconntrack is a XML-RPC server for tracking NetFilter connections over networks"
LONG_DESCRIPTION = open("README").read() + open("CHANGELOG").read()
KEYWORDS = "netfilter conntrack xmlrpc"
REQUIRES = ("pynetfilter_conntrack>=0.4", "IPy>=0.51")

CLASSIFIERS = [
    "Development Status :: 4 - Beta",
    "Natural Language :: English",
    "Environment :: Console",
    "Intended Audience :: System Administrators",
    "License :: OSI Approved :: GNU General Public License (GPL)",
    "Operating System :: POSIX :: Linux",
    "Programming Language :: Python",
    "Topic :: System :: Networking :: Monitoring"]

option = {}
if use_setuptools:
    option["zip_safe"] = True
    option["install_requires"] = REQUIRES

setup(
    name=nuconntrack.PACKAGE,
    version=nuconntrack.VERSION,
    license=nuconntrack.LICENSE,
    url=nuconntrack.WEBSITE,
    download_url=nuconntrack.WEBSITE,
    description=DESCRIPTION,
    long_description=LONG_DESCRIPTION,
    classifiers=CLASSIFIERS,
    author="Damien Boucard",
    author_email="damien.boucard AT inl.fr",
    keywords=KEYWORDS,
    packages=["nuconntrack", ""],
    platforms=['Linux'],
    package_dir={'nuconntrack': 'nuconntrack'},
    **option)

