

class DataSource(object):

    # dport / start / proto
    def _arg_int(self, args, argname):

        if argname == 'proto':
            self.__arg_proto(args, argname)
            return
        if argname == 'tcp_dport' and 'dport' in args:
            val = args.pop('dport')
            args[argname] = val

        if argname not in args:
            return

        self.query += """AND %s = %d
                      """ % (argname, args[argname])


    def _arg_ip(self, args, argname):

        # UGLY HACK because of dpi table name (src instead of ip_saddr)
        if 'ip_saddr' in args:
            args['ip_saddr_str'] = args.pop('ip_saddr')
        if 'ip_daddr' in args:
            args['ip_daddr_str'] = args.pop('ip_daddr')

        if not argname in args:
            return

        self.query += """AND %s = ('%s')::inet
                      """ % (argname, args[argname])


    def __arg_proto(self, args, argname):

        if argname not in args and argname not in self.DEFAULT_ARGS:
            return

        include_default = self.DEFAULT_ARGS['include'] if 'include' in self.DEFAULT_ARGS else True
        default_proto = self.DEFAULT_ARGS['proto'] if 'proto' in self.DEFAULT_ARGS else None
        args_proto = args['proto'] if 'proto' in args else None
        include_args = args['include'] if 'include' in args else True

        protos = None
        default_proto = [default_proto] if default_proto and not isinstance(default_proto, list) else default_proto
        args_proto = [args_proto] if args_proto and not isinstance(args_proto, list) else args_proto

        if args_proto and include_args:
            for index, proto in enumerate(args_proto):
                self.query += """AND""" if index == 0 else """OR """

                if index == 0 and len(args_proto) > 0:
                    self.query += """("""
                self.query += """ %d = ANY(proto_path)
                                  """ % proto

                if index + 1 == len(args_proto):
                    self.query += """)"""
        elif args_proto and not include_args:
            for proto in args_proto:
                self.query += """ AND NOT %d = ANY(proto_path)
                              """ % proto


        if default_proto and include_default:
            for index, proto in enumerate(default_proto):
                self.query += """AND""" if index == 0 else """OR """

                if index == 0 and len(default_proto) > 0:
                    self.query += """("""
                self.query += """ %d = ANY(proto_path)
                         """ % proto

                if index + 1 == len(default_proto):
                    self.query += """)"""
        elif default_proto and not include_default:
            for proto in default_proto:
                self.query += """AND NOT %d = ANY(proto_path)
                              """ % proto

    def _arg_order_by(self, args):
        if 'sortby' in args:
            query_args = (args['sortby'], args['sort'])
            self.query += """ ORDER BY %s %s
                          """ % query_args
        elif 'sortby' in self.DEFAULT_ARGS and 'sort' in self.DEFAULT_ARGS:
            query_args = (self.DEFAULT_ARGS['sortby'], self.DEFAULT_ARGS['sort'])
            self.query += """ ORDER BY %s %s
                          """ % query_args


        
