# -*- coding: utf-8 -*-

"""
Copyright (C) 2008-2011 EdenWall Technologies
Written by Romain Bignon <romain AT inl.fr>

This file is part of NuFirewall. 
 
 NuFirewall is free software: you can redistribute it and/or modify 
 it under the terms of the GNU General Public License as published by 
 the Free Software Foundation, version 3 of the License. 
 
 NuFirewall is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 GNU General Public License for more details. 
 
 You should have received a copy of the GNU General Public License 
 along with NuFirewall.  If not, see <http://www.gnu.org/licenses/>

$Id: nulog_table.py 13047 2009-10-02 14:48:26Z eric $
"""

#from copy import deepcopy
from nulog.client.qt.fetchers.base import BaseFetcher

class NudpiTableFetcher(BaseFetcher):

    module = 'nudpi'
    available_args = None

    def getArgs(self):
        if self.available_args is None:
            self.available_args = self.call(self.module, 'table_filters', self.fragment.type)
        return self.available_args

    def count(self, callback):
        count_args = {'count': True}
        count_args.update(self.my_args)
        return self.asyncall(self.module, 'table', self.fragment.type, count_args, callback=callback, errback=self._errorHandler, cache=True)

    def fetchClassification(self, callback):
        self.asyncall('nudpi', 'getClassification', callback=callback, errback=self._errorHandler, cache=True)

    def fetch(self, callback):

#        self.my_args = self.fragment.args
        self.my_args.update(self.fragment.args)
        self.my_args.update(self.args)
        self.asyncall(self.module, 'table', self.fragment.type, self.my_args, callback=callback, errback=self._errorHandler, cache=True)

class OcsFetcher(NudpiTableFetcher):

    module = 'ocs'

class NulogTableFetcher(NudpiTableFetcher):

    module = 'nulog'
