#coding: utf-8

"""
Copyright (C) 2008-2011 EdenWall Technologies
Written by Romain Bignon <romain AT inl.fr>

This file is part of NuFirewall. 
 
 NuFirewall is free software: you can redistribute it and/or modify 
 it under the terms of the GNU General Public License as published by 
 the Free Software Foundation, version 3 of the License. 
 
 NuFirewall is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 GNU General Public License for more details. 
 
 You should have received a copy of the GNU General Public License 
 along with NuFirewall.  If not, see <http://www.gnu.org/licenses/>
"""

from nucentral.common import tr

default_settings = \
    {'frags': {
    ############################################# NUDPI ###################################################
#                'Classification' : {'args' : {},
#                                          'title' : tr('All Protocols'),
#                                          'type' : 'GetClassification',
#                                          'view' : 'treeview',
#                                          },
                # Traffic
                'TrafficTable' : {'args' : {},
                                          'title' : tr('Traffic'),
                                          'type' : 'TrafficTable',
                                          'view' : 'static_line',
                                          },
                'ProtoTimeTable' : {'args' : {},
                                          'title' : tr('Top Traffic per Protocol'),
                                          'type' : 'ProtoTimeTable',
                                          'view' : 'static_line',
                                          },
                'ProtoTimeTable_80' : {'args' : {'dport' : 80},
                                          'title' : tr('Top Traffic per Protocol on dport 80'),
                                          'type' : 'ProtoTimeTable',
                                          'view' : 'static_line',
                                          },
                # Classification : all protocols families and protocols
                'AllProtoTable' : {'args' : {"classification" : True},
                                          'title' : tr('All Protocols'),
                                          'type' : 'AllProtoTable',
                                          'view' : 'treeview',
                                          },
               # *************** DPort ******************
                'DportTable_most' : {'args' : {'order_by' : 'DESC', 'limit' : 10},
                                          'title' : tr('Most Used Destination Ports'),
                                          'type' : 'DportTable_most',
                                          'view' : 'histo',
                                          },
                'DportTable_less' : {'args' : {'order_by' : 'ASC', 'limit' : 10},
                                          'title' : tr('Least Used Destination Ports'),
                                          'type' : 'DportTable_less',
                                          'view' : 'histo',
                                          },
                'DportTable_most_encrypted' : {'args' : {'order_by' : 'DESC', 'limit' : 10},
                                          'title' : tr('Most Used Encrypted Destination Ports'),
                                          'type' : 'DportTable_most_encrypted',
                                          'view' : 'histo',
                                          },
                'DportTable_most_unencrypted' : {'args' : {'order_by' : 'DESC', 'limit' : 10},
                                          'title' : tr('Most Used Unencrypted Destination Ports'),
                                          'type' : 'DportTable_most_unencrypted',
                                          'view' : 'histo',
                                          },

#                'DportTable_unknown' : {'args' : {'proto' : 4,'order_by' : 'ASC', 'limit' : 10},
#                                          'title' : tr('Most Used Destination Ports'),
#                                          'type' : 'DportTable_most',
#                                          'view' : 'histo',
#                                          },
#                'DportTable_proto' : {'args' : {'order_by' : 'DESC','limit' : 10},
#                                      'title' : 'Destination port',
#                                      'type' : 'DportTable',
#                                      'view' : 'histo',
#                                      },
#                'DportTable_user' : {'args' : {'order_by' : 'DESC','limit' : 10},
#                                      'title' : 'Destination port',
#                                       'type' : 'DportTable',
#                                      'view' : 'histo',
#                                      },
                # **************** Protocols *****************
                'MostUsedProtoTable_encrypted' : {'args' :  {},
                                          'title' : tr('Encrypted protocols'),
                                           'type' : 'MostUsedProtoTable_encrypted',
                                          'view' : 'concentric_pie',
                                          },
                'MostUsedProtoTable_unencrypted' : {'args':  {},
                                              'title' : 'Unencrypted protocols',
                                               'type' : 'MostUsedProtoTable_unencrypted',
                                              'view' : 'concentric_pie',
                                              },

#                'MostUsedProtoTable_unencrypted_80' : {'args':  {'port_80' : True},
#                                              'title' : 'Unencrypted protocols',
#                                               'type' : 'MostUsedProtoTable_unencrypted',
#                                              'view' : 'concentric_pie',
#                                              },

                'MostUsedProtoTable_http' : {'args' :  {},
                                      'title' : 'Top HTTP',
                                      'type' : 'MostUsedProtoTable_http',
                                      'view' : 'treeview',
                                      },

                'MostUsedProtoTable_port80' : {'args' :  {'dport' : 80},
                                      'title' : 'Top dport 80',
                                      'type' : 'MostUsedProtoTable',
                                      'view' : 'treeview',
                                      },

                'MostUsedProtoTable_ssl' : {'args' :  {},
                                      'title' : 'Top SSL',
                                      'type' : 'MostUsedProtoTable_ssl',
                                      'view' : 'treeview',
                                      },
#                'MostUsedProtoTable_unknown' : {'args' : {'proto' : 4, 'include' : True, 'is_base' : False, 'limit' : 10},
#                                      'title' : 'Top Unkonwn',
#                                      'type' : 'MostUsedProtoTable_unknown',
#                                      'view' : 'treeview',
#                                      },
                'MostUsedProtoTable' : {'args' : {'is_base' : True, 'limit' : 10},
                                      'title' : tr('Top Ten Protocols'),
                                      'type' : 'MostUsedProtoTable',
                                      'view' : 'treeview',
                                    },
                'MostUsedProtoTable_peer2peer' : {'args' : {'is_base' : True,
                                                            'limit' : 10,
                                                            'family' : 416,
                                                            'proto' : [31, 35, 52, 53, 138, 184, 223, 272, 274, 278, 279]},
                                      'title' : tr('Top Ten Peer-to-Peer'),
                                      'type' : 'MostUsedProtoTable',
                                      'view' : 'treeview',
                                    },
                'MostUsedProtoTable_audio_video' : {'args' : {'is_base' : True,
                                                            'limit' : 10,
                                                            'family' : 401,
                                                            'proto' : [60, 61, 113, 115, 123, 143, 160, 174, 175, 176, 179, 181, 182, 228, 239, 251]},
                                      'title' : tr('Top Ten Audio & Video'),
                                      'type' : 'MostUsedProtoTable',
                                      'view' : 'treeview',
                                    },
                'MostUsedProtoTable_instant_messaging' : {'args' : {'is_base' : True,
                                                            'limit' : 10,
                                                            'family' : 409,
                                                            'proto' : [8, 50, 94, 142, 156, 183, 237, 238, 273, 275, 276, 281]},
                                      'title' : tr('Top Ten Instant Messaging'),
                                      'type' : 'MostUsedProtoTable',
                                      'view' : 'treeview',
                                    },
                'HostProtoTable' : {'args' :  {},
                                      'title' : tr('Used Protocols'),
                                      'type' : 'HostProtoTable',
                                      'view' : 'treeview',
                                      },
                'HostProtoTable_http' : {'args' : {},
                                      'title' : tr('HTTP Protocols'),
                                      'type' : 'HostProtoTable_http',
                                      'view' : 'treeview',
                                      },
                'HostProtoTable_ssl' : {'args' : {},
                                      'title' : tr('SSL Protocols'),
                                      'type' : 'HostProtoTable_ssl',
                                      'view' : 'concentric_pie',
                                      },
                'HostProtoTable_encrypted' : {'args' : {},
                                      'title' : tr('Encrypted Protocols'),
                                      'type' : 'HostProtoTable_encrypted',
                                      'view' : 'concentric_pie',
                                      },
                'HostProtoTable_unencrypted' : {'args' : {},
                                      'title' : tr('Unencrypted Protocols'),
                                      'type' : 'HostProtoTable_unencrypted',
                                      'view' : 'concentric_pie',
                                      },
                'ProtoOnDportTable' : {'args' : {},
                                      'title' : tr('Protocols on Destination Port'),
                                      'type' : 'ProtoOnDportTable',
                                      'view' : 'concentric_pie',
                                      },

                'UsersOnDportTable' : {'args' : {'limit' : 10},
                                      'title' : tr('Users on Destination Port'),
                                      'type' : 'UsersOnDportTable',
                                      'view' : 'histo',
                                      },
                'UsersOnDportTable_http' : {'args' : {}, # {'limit' : 10, 'proto' : 67},
                                      'title' :tr('Users on HTTP Destination Port'),
                                      'type' : 'UsersOnDportTable_http',
                                      'view' : 'pie',
                                      },
                'UsersOnDportTable_ssl' : {'args' : {}, # {'limit' : 10, 'proto' : 199},
                                      'title' : tr('Users on SSL Destination Port'),
                                      'type' : 'UsersOnDportTable_ssl',
                                      'view' : 'pie',
                                      },
                # *************** Sources ********************
                'MostUsedSourcesTable_http' : {'args' : {},
                                      'title' : tr('Top Ten Sources for HTTP'),
                                      'type' : 'MostUsedSourcesTable_http',
                                      'view' : 'histo',
                                      },

                'MostUsedSourcesTable_port80' : {'args' : {'dport' : 80},
                                      'title' : tr('Top Ten Sources for dport 80'),
                                      'type' : 'MostUsedSourcesTable',
                                      'view' : 'histo',
                                      },

                'MostUsedSourcesTable_peer2peer' : {'args' : {'limit' : 10,
                                                              'family' : 416,
                                                              'proto' : [31, 35, 52, 53, 138, 184, 223, 272, 274, 278, 279]},
                                      'title' : tr('Top Ten Sources for Peer-to-Peer'),
                                      'type' : 'MostUsedSourcesTable',
                                      'view' : 'histo',
                                      },
                'MostUsedSourcesTable_audio_video' : {'args' : {'limit' : 10,
                                                              'family' : 401,
                                                              'proto' : [60, 61, 113, 115, 123, 143, 160, 174, 175, 176, 179, 181, 182, 228, 239, 251]},
                                      'title' : tr('Top Ten Sources for Audio & Video'),
                                      'type' : 'MostUsedSourcesTable',
                                      'view' : 'histo',
                                      },
                'MostUsedSourcesTable_instant_messaging' : {'args' : {'limit' : 10,
                                                              'family' : 409,
                                                              'proto' : [8, 50, 94, 142, 156, 183, 237, 238, 273, 275, 276, 281]},
                                      'title' : tr('Top Ten Sources for Instant Messaging'),
                                      'type' : 'MostUsedSourcesTable',
                                      'view' : 'histo',
                                      },
                'MostUsedSourcesTable_ssl' : {'args' :  {},
                                      'title' : tr('Top Ten Sources for SSL'),
                                      'type' : 'MostUsedSourcesTable_ssl',
                                      'view' : 'histo',
                                      },
                'MostUsedSourcesTable_unencrypted' : {'args' :  {},
                                      'title' : tr('Top Ten Sources for Unencrypted Proto'),
                                      'type' : 'MostUsedSourcesTable_unencrypted',
                                      'view' : 'pie',
                                      },
                'MostUsedSourcesTable_encrypted' : {'args' :  {},
                                      'title' : tr('Top Ten Sources for Encrypted Proto'),
                                      'type' : 'MostUsedSourcesTable_encrypted',
                                      'view' : 'pie',
                                      },
                'MostUsedSourcesTable_unknown' : {'args' : {},
                                      'title' : tr('Top Ten Sources for Unknown Proto'),
                                      'type' : 'MostUsedSourcesTable_unknown',
                                      'view' : 'pie',
                                      },
                # *************** Destinations ********************
                'MostUsedDestinationTable' : {'args' :  {},
                                      'title' : tr('Top Ten Destinations'),
                                      'type' : 'MostUsedDestinationTable',
                                      'view' : 'histo',
                                      },
                'MostUsedDestinationTable_http' : {'args' :  {},
                                      'title' : tr('Top Ten Destinations for HTTP'),
                                      'type' : 'MostUsedDestinationTable_http',
                                      'view' : 'histo',
                                      },
                'MostUsedDestinationTable_port80' : {'args' :  {'dport' : 80},
                                      'title' : tr('Top Ten Destinations for dport 80'),
                                      'type' : 'MostUsedDestinationTable',
                                      'view' : 'histo',
                                      },

                'MostUsedDestinationTable_ssl' : {'args' :  {},
                                      'title' : tr('Top Ten Destinations for SSL'),
                                      'type' : 'MostUsedDestinationTable_ssl',
                                      'view' : 'histo',
                                      },
                'MostUsedDestinationTable_encrypted' : {'args' :  {},
                                      'title' : tr('Top Ten Destinations for Encrypted Proto'),
                                      'type' : 'MostUsedDestinationTable_ssl',
                                      'view' : 'histo',
                                      },
                'MostUsedDestinationTable_unencrypted' : {'args' :  {},
                                      'title' : tr('Top Ten Destinations for Unencrypted Proto'),
                                      'type' : 'MostUsedDestinationTable_ssl',
                                      'view' : 'histo',
                                      },
                'MostUsedDestinationTable_unknown' : {'args' :  {},
                                      'title' : tr('Top Ten Destinations for Unknown Proto'),
                                      'type' : 'MostUsedDestinationTable_unknown',
                                      'view' : 'histo',
                                      },
#                'MostUsedSourcesTable_most' : {'args' : {'limit' : 10},
#                                      'title' : 'Top Ten Sources',
#                                      'type' : 'MostUsedSourcesTable',
#                                      'view' : 'pie',
#                                      },
                'MostUsedSourcesTable' : {'args' : {'limit' : 10},
#                                      'title' : 'Sources on Protocol',
                                      'title' : tr('Top Ten Sources'),
                                      'type' : 'MostUsedSourcesTable',
                                      'view' : 'pie',
                                      },
                # ******************* Users *****************
                'MostUsedUsersTable' : {'args' : {'limit' : 10},
                                      'title' : tr('Top Ten Users'),
                                      'type' : 'MostUsedUsersTable',
                                      'view' : 'histo',
                                      },
                'MostUsedUsersTable_peer2peer' : {'args' : {'limit' : 10,
                                                            'family' : 416,
                                                            'proto' : [31, 35, 52, 53, 138, 184, 223, 272, 274, 278, 279]},
                                      'title' : tr('Top Ten Users for Peer-to-Peer'),
                                      'type' : 'MostUsedUsersTable',
                                      'view' : 'histo',
                                      },
                'MostUsedUsersTable_audio_video' : {'args' : {'limit' : 10,
                                                            'family' : 401,
                                                            'proto' : [60, 61, 113, 115, 123, 143, 160, 174, 175, 176, 179, 181, 182, 228, 239, 251]},
                                      'title' : tr('Top Ten Users for Audio & Video'),
                                      'type' : 'MostUsedUsersTable',
                                      'view' : 'histo',
                                      },
                'MostUsedUsersTable_instant_messaging' : {'args' : {'limit' : 10,
                                                            'family' : 409,
                                                            'proto' :  [8, 50, 94, 142, 156, 183, 237, 238, 273, 275, 276, 281]},
                                      'title' : tr('Top Ten Users for Instant Messaging'),
                                      'type' : 'MostUsedUsersTable',
                                      'view' : 'histo',
                                      },
                'MostUsedUsersTable_http' : {'args' : {'proto' : 67, 'limit' : 10},
                                      'title' : tr('Top Ten Users for HTTP'),
                                      'type' : 'MostUsedUsersTable_http',
                                      'view' : 'histo',
                                      },
                'MostUsedUsersTable_ssl' : {'args' : {'proto' : 199, 'limit' : 10},
                                      'title' : tr('Top Ten Users for SSL'),
                                      'type' : 'MostUsedUsersTable_ssl',
                                      'view' : 'histo',
                                      },
                'UserProtoTable' : {'args' : {'limit' : 10},
                                      'title' : tr('Used Protocols'),
                                      'type' : 'UserProtoTable',
                                      'view' : 'concentric_pie',
                                      },
                'UserProtoTable_http' : {'args' :  {},
                                      'title' : tr('HTTP Protocols'),
                                      'type' : 'UserProtoTable_http',
                                      'view' : 'treeview',
                                      },
                'UserProtoTable_ssl' : {'args' :  {},
                                      'title' : tr('SSL Protocols'),
                                      'type' : 'UserProtoTable_ssl',
                                      'view' : 'concentric_pie',
                                      },
                'UserProtoTable_encrypted' : {'args' :  {},
                                      'title' : tr('Encrypted Protocols'),
                                      'type' : 'UserProtoTable_encrypted',
                                      'view' : 'concentric_pie',
                                      },
                'UserProtoTable_unencrypted' : {'args' :  {},
                                      'title' : tr('Unencrypted Protocols'),
                                      'type' : 'UserProtoTable_unencrypted',
                                      'view' : 'concentric_pie',
                                      },

                'HostsOnDportTable' : {'args' : {},
                                      'title' : tr('Hosts on Destination Port'),
                                      'type' : 'HostsOnDportTable',
                                      'view' : 'histo',
                                      },
                'HostsOnDportTable_dropped' : {'args' : {},
                                      'title' : tr('Dropped Host Port Connections'),
                                      'type' : 'HostsOnDportTable_dropped',
                                      'view' : 'table',
                                      },
                'HostsOnDportTable_http' : {'args' :  {},
                                      'title' : tr('Hosts on HTTP Destination Port'),
                                      'type' : 'HostsOnDportTable_http',
                                      'view' : 'pie',
                                      },
                'HostsOnDportTable_ssl' : {'args' :  {},
                                      'title' : tr('Hosts on SSL Destination Port'),
                                      'type' : 'HostsOnDportTable_ssl',
                                      'view' : 'pie',
                                      },
    ################################### END NUDPI ####################################################

    ################################### NULOG #######################################################
                'AppTable_most_drop': {'args': {'sort': 'DESC',
                                     'sortby': 'packets',
                                     'state': 0
                                    },
                            'background_color': '16777215',
                            'title': tr('Dropped Applications'),
                            'type': 'AppTable',
                            'view': 'pie'},
               'AppTable_accept': {'args': {'sort': 'DESC',
                                            'sortby': 'packets',
                                            'state': 1
                                           },
                                   'background_color': '16777215',
                                   'title': tr('Most Accepted Applications'),
                                   'type': 'AppTable',
                                   'view': 'histo'},
               'AppTable': {'args': {},
                                   'background_color': '16777215',
                                   'title': tr('Applications in Use'),
                                   'type': 'AppTable',
                                   'view': 'histo'},
               'AppTable_currently': {'args': {'state': 1, 'sortby' : 'packets'},
                                   'background_color': '16777215',
                                   'title': tr('Applications Currently Used'),
                                   'type': 'AppTable',
                                   'view': 'table'},
               'AppTable_drop': {'args': { 'sort': 'DESC',
                                            'sortby': 'packets',
                                            'state': 0},
                                   'background_color': '16777215',
                                   'title': tr('Dropped Applications'),
                                   'type': 'AppTable',
                                   'view': 'histo'},
               'AppTable_last_drop': {'args': {'state': 0},
                                  'background_color': '16777215',
                                  'title': tr('Last Dropped Applications'),
                                  'type': 'AppTable',
                                  'view': 'pie'},
               'ConUserTable': {'args': {},
                                'background_color': '16777215',
                                'title': tr('Connected Users'),
                                'type': 'ConUserTable',
                                'view': 'table'},
               #'ConntrackTable': {'args': {},
               #                   'background_color': '16777215',
               #                   'title': tr('Conntrack'),
               #                   'type': 'ConntrackTable',
               #                   'view': 'table'},
               'IDSIPSTable': {'args': {'start':0, 'limit':30},
                               'title': tr('IDS-IPS Logs'),
                               'type': 'IDSIPSTable',
                               'view': 'table'},
               'ProxyRequestTable': {'args': {},
                                      'title': tr('Proxy Logs'),
                                      'type': 'ProxyRequestTable',
                                      'view': 'table'},
               'ProxyDomainsTable': {'args': {},
                                     'title': tr('Top Domains'),
                                     'type': 'ProxyDomainsTable',
                                     'view': 'table'},
               'ProxyUsersTable': {'args': {},
                                   'title': tr('Top Users'),
                                   'type': 'ProxyUsersTable',
                                   'view': 'table'},
               'ProxyHostsTable': {'args': {},
                                   'title': tr('Top Hosts'),
                                   'type': 'ProxyHostsTable',
                                   'view': 'table'},
#               'HostPortTable_drop': {'args': {'state': 0},
#                                 'background_color': '16777215',
#                                 'title': tr('Dropped Host Port Connections'),
#                                 'type': 'HostPortTable',
#                                 'view': 'table'},
               'HostPortTable_accept': {'args': {'proto': 'tcp', 'state': 1},
                                       'background_color': '16777215',
                                       'title': tr('Host Port Connections'),
                                       'type': 'HostPortTable',
                                       'view': 'table'},
               'IPdstTable': {'args': {'sortby': 'packets'},
                              'background_color': '16777215',
                              'title': tr('Destination IP'),
                              'type': 'IPdstTable',
                              'view': 'pie'},
               'IPsrcTable': {'args': {},
                              'background_color': '16777215',
                              'title': tr('Last Active Hosts'),
                              'type': 'IPsrcTable',
                              'view': 'table'},
               'IPsrcTable_drop': {'args': {'state': 0},
                              'background_color': '16777215',
                              'title': tr('Dropped Hosts'),
                              'type': 'IPsrcTable',
                              'view': 'table'},
               'IPsrcTable_most_drop': {'args': {'state': 0, 'sortby': 'packets'},
                              'title': tr('Most Dropped Hosts'),
                              'type': 'IPsrcTable',
                              'view': 'table'},
               'IPsrcTable_accept': {'args': {'sort': 'DESC',
                                              'sortby': 'packets',
                                              'state': 1},
                                     'background_color': '16777215',
                                     'title': tr('Most Accepted Hosts'),
                                     'type': 'IPsrcTable',
                                     'view': 'histo'},
               'IPsrcTable_active': {'args': {'state': 1},
                                     'background_color': '16777215',
                                     'title': tr('Accepted Hosts'),
                                     'type': 'IPsrcTable',
                                     'view': 'table'},
               'IPsrcTable_drop': {'args': { 'sort': 'DESC',
                                              'sortby': 'packets',
                                              'state': 0},
                                     'background_color': '16777215',
                                     'title': tr('Most Dropped Hosts'),
                                     'type': 'IPsrcTable',
                                     'view': 'histo'},
               'LastPacketsStream': {'args': {'interval': 5},
                                     'background_color': '16777215',
                                     'title': tr('Traffic per Connection'),
                                     'type': 'LastPacketsStream',
                                     'view': 'line'},
               'LastPacketsStream_drop': {'args': {'interval': 5, 'state': 0},
                                            'background_color': '16777215',
                                            'title': tr('Dropped Connections'),
                                            'type': 'LastPacketsStream',
                                            'view': 'line'},
               'PacketsCountTable': {'args': {},
                                     'title': tr('Connections per Day'),
                                     'type': 'PacketsCountTable',
                                     'view': 'histo'},
               'PacketsCountTable_drop': {'args': {'state': 0},
                                          'title': tr('Dropped Connections per Day'),
                                          'type': 'PacketsCountTable',
                                          'view': 'histo'},
               'PacketInfo': {'args': {},
                              'background_color': '16777215',
                              'title': tr('Packet Info'),
                              'type': 'PacketInfo',
                              'view': 'packetinfo'},
                # Server version : 3.0-2
               'LastPacket': {'args': {'limit' : 30},
                               'background_color': '16777215',
                               'title': tr('Connection List'),
                               'type': 'LastPacket',
                               'view': 'table'},
                # Server version : 3.0-2
                'InputPacket': {'args': {'limit' : 30},
                               'background_color': '16777215',
                               'title': tr('Firewall Connection List'),
                               'type': 'InputPacket',
                               'view': 'table'},
               'TCPTable': {'args': {},
                            'background_color': '16777215',
                            'title': tr('TCP Ports'),
                            'type': 'TCPTable',
                            'view': 'pie'},
               'TrafficStream': {'args': {'interval': 15},
                                 'background_color': '16777215',
                                 'title': tr('Traffic'),
                                 'type': 'TrafficStream',
                                 'view': 'line'},
               'UserAppTable_drop': {'args': {'state': 0, 'sortby': 'packets'},
                                'background_color': '16777215',
                                'title': tr('Dropped User Applications'),
                                'type': 'UserAppTable',
                                'view': 'table'},
               'UserAppTable_accept': {'args': {'state': 1, 'sortby': 'packets'},
                                       'background_color': '16777215',
                                       'title': tr('Most Accepted User Applications'),
                                       'type': 'UserAppTable',
                                       'view': 'table'},
               'UserTable_most_drop': {'args': {'sort': 'DESC',
                                      'sortby': 'packets',
                                      'state': 0},
                             'background_color': '16777215',
                             'title': tr('Most Dropped Users'),
                             'type': 'UserTable',
                             'view': 'histo'},
               'UserTable': {'args': {},
                                    'background_color': '16777215',
                                    'title': tr('Users'),
                                    'type': 'UserTable',
                                    'view': 'table'},
               'UsersHistoryTable': {'args': { 'sort': 'DESC',
                                             'sortby': 'username' },
                                    'background_color': '16777215',
                                    'title': tr('User session history'),
                                    'type': 'UsersHistoryTable',
                                    'view': 'table'},
                'AuthFail' : {      'args' : {'limit' : 30},
                                    'background_color': '16777215',
                                    'title': tr('Authentication Failed'),
                                    'type': 'AuthFail',
                                    'view': 'table'
                              },
               'UserTable_accept': {'args': {'state': 1},
                                    'background_color': '16777215',
                                    'title': tr('Most Accepted Users'),
                                    'type': 'UserTable',
                                    'view': 'histo'},
               'UserTable_drop': {'args': {'sort': 'DESC',
                                             'sortby': 'end_time',
                                             'state': 0},
                                    'background_color': '16777215',
                                    'title': tr('Last Dropped Users'),
                                    'type': 'UserTable',
                                    'view': 'histo'},
               'UserTable_most': {'args': {'sort': 'DESC',
                                             'sortby': 'packets'},
                                    'background_color': '16777215',
                                    'title': tr('Most Active Users'),
                                    'type': 'UserTable',
                                    'view': 'histo'},
               'UserTable_drop': {'args': {'sort': 'DESC',
                                             'sortby': 'packets',
                                             'state': 0},
                                    'background_color': '16777215',
                                    'title': tr('Most Dropped Users (logs)'),
                                    'type': 'UserTable',
                                    'view': 'histo'},
               'MostDroppedUserTable': {'args': {'sort': 'DESC'},
                                    'background_color': '16777215',
                                    'title': tr('Most Dropped Users'),
                                    'type': 'MostDroppedUserTable',
                                    'view': 'pie'},
               'MostDroppedSourceTable': {'args': {'sort': 'DESC'},
                                    'background_color': '16777215',
                                    'title': tr('Most Dropped Sources'),
                                    'type': 'MostDroppedSourceTable',
                                    'view': 'histo'},
                'LastDroppedConnections' : {'args': {'sort': 'DESC'},
                                    'background_color': '16777215',
                                    'title': tr('Last Dropped Connections'),
                                    'type': 'LastDroppedConnections',
                                    'view': 'table'
                                           }
    },
     'links': {
               ### NUDPI
               'proto' : 'proto',
#               'dport' : 'top_sources',
#               'tcp_dport' : 'top_sources',
               'tcp_dport' : 'dport',
               'dport' : 'dport',
               'main' : 'top_sources',
#               'sport' : 'dport',

#               'user_id' : 'user_id',

               ### NULOG
               'client_app': 'client_app',
#               'dport': 'dport',
               'ip_daddr': 'ip_daddr',
               'ip_saddr': 'ip_saddr',
               'orig_ipv6_src': 'ip_saddr',
               'orig_ipv6_dst': 'ip_daddr',
               'orig_ipv4_src': 'ip_saddr',
               'orig_ipv4_dst': 'ip_daddr',
#               'orig_port_src': 'sport',
               'orig_port_dst': 'dport',
               'packet_id': 'packet_id',
#               'sport': 'sport',
#               'username': 'username',
               'domain': 'proxy_domain',
               'proxy_username': 'proxy_user'
               },
     'pages': {
               'main': {'args': {},
                              'filters': 'proto tcp_dport ip_saddr', #'ip_saddr ip_daddr ip_addr username sport '\
                                         #'dport state proto oob_prefix client_app start_time end_time firewall',
                           'frames': {
                                      '0': {'frags': 'MostUsedProtoTable',
                                            'pos': 0},
                                     '1' : {'frags' : 'DportTable_most', # MostUsedUsersTable_http
                                             'pos' : 1},
                                     '2' : {'frags' : 'ProtoTimeTable',
                                             'pos' : 2},
                                     '3' : {'frags' : 'MostUsedSourcesTable', #MostUsedUsersTable
                                             'pos' : 3},
                                      },
                           'title': tr('Main View')},
               'last_dropped_connections': {'args': {},
                              'filters': 'tcp_dport ip_saddr ip_daddr',
                           'frames': {
                                      '0': {'frags': 'LastDroppedConnections',
                                            'pos': 0},
                                      },
                           'title': tr('Last Dropped Connections')},
               'top_unencrypted': {'args': {},
                              'filters': 'proto tcp_dport ip_saddr',
                            'frames' : {'0' : {'frags' : 'MostUsedProtoTable_unencrypted',
                                               'pos' : 0},
                                        '1' : {'frags' : 'MostUsedSourcesTable_unencrypted', #MostUsedUsersTable_unencrypted
                                               'pos' : 1},
                                        '2' : {'frags' : 'MostUsedDestinationTable_unencrypted',
                                               'pos' : 2},
                                        '3' : {'frags' : 'MostUsedProtoTable_http',
                                               'pos' : 3}, },
                            'title': tr('Unencrypted Protocols')},
               'all_proto': {'args': {},
                            'filters': 'proto tcp_dport ip_saddr',
                            'frames' : {'0' : {'frags' : 'AllProtoTable',
                                               'pos' : 0}, },
                            'title': tr('Network Flows')},
                'encrypted_proto': {'args': {},
                            'filters': 'proto tcp_dport ip_saddr',
                            'frames' : {'0' : {'frags' : 'MostUsedProtoTable_encrypted',
                                               'pos' : 0},
                                        '1' : {'frags' : 'DportTable_most_encrypted',
                                               'pos' : 1},
                                        '2' : {'frags' : 'MostUsedProtoTable_ssl',
                                               'pos' : 2},
                                        '3' : {'frags' : 'MostUsedSourcesTable_encrypted',
                                               'pos' : 3}, },
                            'title': tr('Encrypted Network Flows')},
                'unencrypted_proto': {'args': {},
                            'filters': 'proto tcp_dport ip_saddr',
                            'frames' : {'0' : {'frags' : 'MostUsedProtoTable_unencrypted',
                                               'pos' : 0},
                                        '1' : {'frags' : 'DportTable_most_unencrypted',
                                               'pos' : 1},
                                        '2' : {'frags' : 'MostUsedProtoTable_http',
                                               'pos' : 2},
                                        '3' : {'frags' : 'MostUsedSourcesTable_unencrypted',
                                               'pos' : 3}, },
                            'title': tr('Unencrypted Network Flows')},
                'top_encrypted': {'args': {},
                            'filters': 'proto tcp_dport ip_saddr',
                            'frames' : {'0' : {'frags' : 'MostUsedProtoTable_encrypted',
                                               'pos' : 0},
                                        '1' : {'frags' : 'MostUsedSourcesTable_encrypted', #MostUsedUsersTable_encrypted
                                               'pos' : 1},
                                        '2' : {'frags' : 'MostUsedDestinationTable_encrypted',
                                               'pos' : 2},
                                        '3' : {'frags' : 'MostUsedProtoTable_ssl',
                                               'pos' : 3}, },
#                           'frames': {'0': {'frags': 'ProtoTable_most ProtoTable_most_http ProtoTable_unencrypted ProtoTable_encrypted',
#                                            'pos': 0},},
#                           'title': tr('Encrypted Protocols')},
                            'title': tr('Details for Encrypted Protocols')},
                'top_unknown': {'args': {},
                            'filters': 'proto tcp_dport ip_saddr',
                            'frames' : {'0' : {'frags' : 'MostUsedSourcesTable_unknown', #MostUsedUsersTable_unknown
                                               'pos' : 0},
                                        '1' : {'frags' : 'MostUsedSourcesTable_unknown',
                                               'pos' : 1},
                                        '2' : {'frags' : 'MostUsedDestinationTable_unknown',
                                               'pos' : 2},
                                        '3' : {'frags' : 'MostUsedProtoTable_unknown',
                                               'pos' : 3}, },
                            'title': tr('Unknown Protocols')},
                'top_sources_port80': {'args': {},
                           'filters': 'tcp_dport ip_saddr',
                           'frames': {
                                      '0': {'frags': 'MostUsedProtoTable_port80',
                                            'pos': 0},
                                      '1': {'frags': 'MostUsedSourcesTable_port80',
                                            'pos': 1},
                                      '2' : {'frags' : 'ProtoTimeTable_80',
                                               'pos' : 2},
                                      '3' : {'frags' : 'MostUsedDestinationTable_port80',
                                             'pos' : 3},
                                     },
                           'title': tr('Details for port 80')},
                'dport': {'args': {},
                           'filters': 'tcp_dport ip_saddr',
                           'frames': {
                                      '0': {'frags': 'MostUsedProtoTable',
                                            'pos': 0},
                                      '1': {'frags': 'MostUsedSourcesTable',
                                            'pos': 1},
                                      '2' : {'frags' : 'ProtoTimeTable',
                                               'pos' : 2},
                                      '3' : {'frags' : 'MostUsedDestinationTable',
                                             'pos' : 3},
                                     },
                           'title': tr('Details for port')},
                'top_sources_ssl': {'args': {},
                           'filters': 'tcp_dport ip_saddr',
                           'frames': {'0': {'frags': 'MostUsedProtoTable_ssl',
                                            'pos': 0},
                                      '1': {'frags': 'MostUsedSourcesTable_ssl',
                                            'pos': 1},
                                      '2' : {'frags' : 'MostUsedProtoTable_encrypted',
                                               'pos' : 2},
                                      '3' : {'frags' : 'MostUsedDestinationTable_ssl',
                                             'pos' : 3},
                                     },
                           'title': tr('Details for SSL protocol')},
                'ip_saddr': {'args': {},
                              'filters': 'proto tcp_dport',
                             'frames': {
                                      '0': {'frags': 'HostProtoTable',
                                            'pos': 0},
                                      '1' : {'frags': 'DportTable_most',
                                            'pos': 1},
                                      '2' : {'frags': 'HostProtoTable_unencrypted HostProtoTable_encrypted',
                                            'pos': 2},
                                      '3' : {'frags': 'ProtoTimeTable',
                                            'pos': 3},
                                     },
                           'title': tr('Top Source Protocols')},
                'ip_daddr': {'args': {},
                              'filters': 'proto tcp_dport',
                             'frames': {
                                      '0': {'frags': 'HostProtoTable',
                                            'pos': 0},
                                      '1' : {'frags': 'DportTable_most',
                                            'pos': 1},
                                      '2' : {'frags': 'HostProtoTable_unencrypted',
                                            'pos': 2},
                                      '3' : {'frags': 'HostProtoTable_encrypted',
                                            'pos': 3},
                                     },
                           'title': tr('Top Destination Protocols')},
#                'username': {'args': {},
#                              'filters': 'ip_saddr ip_daddr ip_addr username sport '\
#                                         'dport state proto oob_prefix client_app start_time end_time',
#                            'frames': {'0': {'frags': 'UserProtoTable',
#                                             'pos': 0},
#                                       '1': {'frags': 'DportTable_most',
#                                             'pos': 1},
#                                       '2': {'frags': 'UserProtoTable_unencrypted', 'pos': 2},
#                                       '3': {'frags': 'UserProtoTable_encrypted',
#                                             'pos': 3}},
#                            'title': tr('User')},
#                'user_id' : {'args': {},
#                              'filters': '',
#                           'frames': {
#                                      '0': {'frags': 'UserProtoTable',
#                                            'pos': 0},
#                                      '1' : {'frags': 'DportTable_most',
#                                            'pos': 1},
#                                      '2' : {'frags': 'UserProtoTable_unencrypted',
#                                            'pos': 2},
#                                      '3' : {'frags': 'UserProtoTable_encrypted',
#                                            'pos': 3},
#                                     },
#                           'title': tr('Top User Protocols')},
                'proto': {'args': {},
                              'filters': 'ip_saddr proto tcp_dport',
                           'frames': {'0': {'frags': 'MostUsedSourcesTable', #'MostUsedUsersTable',
                                            'pos': 0},
                                      '1' : {'frags' : 'MostUsedProtoTable_encrypted MostUsedProtoTable_unencrypted',
                                             'pos' : 1},
                                      '2': {'frags': 'MostUsedProtoTable',
                                            'pos': 2},
                                      '3' : {'frags': 'DportTable_most DportTable_less',
                                            'pos': 3},
                                     },
                            'title': tr('Sources')},
                'peer2peer': {'args': {},
                           'filters': 'ip_saddr proto tcp_dport',
                           'frames': {'0': {'frags': 'MostUsedSourcesTable_peer2peer', #MostUsedUsersTable_peer2peer
                                            'pos': 0},
                                      '1' : {'frags' : 'MostUsedProtoTable_peer2peer',
                                             'pos' : 1},
                                     },
                            'title': tr('Sources using Peer-to-Peer')},
                'audio_video': {'args': {},
                              'filters': 'ip_saddr proto tcp_dport',
                           'frames': {'0': {'frags': 'MostUsedSourcesTable_audio_video', #MostUsedUsersTable_audio_video
                                            'pos': 0},
                                      '1' : {'frags' : 'MostUsedProtoTable_audio_video',
                                             'pos' : 1},
                                     },
                            'title': tr('Sources using Audio & Video')},
                'instant_messaging' : {'args': {},
                            'filters': 'ip_saddr proto tcp_dport',
                           'frames': {'0': {'frags': 'MostUsedSourcesTable_instant_messaging', #MostUsedUsersTable_instant_messaging
                                            'pos': 0},
                                      '1' : {'frags' : 'MostUsedProtoTable_instant_messaging',
                                             'pos' : 1},
                                     },
                            'title': tr('Sources using Instant Messaging')},
                'traffic' : {'args': {},
                             'filters': 'ip_saddr ip_daddr tcp_dport proto',
                           'frames': {
                                      '0': {'frags': 'TrafficTable',
                                            'pos': 0},
                                      '1' : {'frags' : 'ProtoTimeTable',
                                             'pos' : 1},
                                     },
                            'title': tr('Traffic')},
#                'dport' : {'args' : {},
#                            'filters' : 'proto ip_saddr',
#                            'frames' : {'0' : {'frags' : 'ProtoOnDportTable',
#                                               'pos' : 0},
#                                        '1' : {'frags' : 'HostsOnDportTable_http HostsOnDportTable_ssl',
#                                               'pos' : 1},
#                                        '2' : {'frags' : 'HostsOnDportTable',
#                                               'pos' : 2},
#                                        '3' : {'frags' : 'DportTable_most DportTable_less',
#                                               'pos' : 3}
#                                        },
#                            'title' : tr('Destination Ports') },
                'classification': {'args': {'classification':True},
                           'frames': {'0' : {'frags' : 'AllProtoTable' ,
                                             'pos' : 0},
                                     },
                           'title': tr('Network Flow Classification')},
                'top_sources': {'args': {},
                           'filters': 'ip_saddr proto tcp_dport',
                           'frames': {
                                      '0': {'frags': 'MostUsedSourcesTable',
                                            'pos': 0},
                                      '1': {'frags': 'MostDroppedSourceTable',
                                            'pos': 1},
                                      '2': {'frags': ' DportTable_most',
                                            'pos': 2},
                                      '3': {'frags': 'DportTable_less',
                                            'pos': 3},
                                     },
                           'title': tr('All sources')},
                'top_users': {'args': {},
                           'filters': 'ip_saddr proto tcp_dport',
                           'frames': {
                                      '0': {'frags': 'UserTable_most',
                                            'pos': 0},
                                      '1': {'frags': 'UserTable_drop',
                                            'pos': 1},
                                      '2': {'frags': 'DportTable_most  DportTable_less',
                                            'pos': 2},
                                      '3': {'frags': 'ConUserTable',
                                            'pos': 3},
                                     },
                           'title': tr('All users')},
                'top_users_http': {'args': {},
                            'filters': 'ip_saddr tcp_dport',
                           'frames': {
                                      '0': {'frags': 'MostUsedProtoTable_http',
                                            'pos': 0},
                                      '1': {'frags': 'MostUsedUsersTable_http',
                                            'pos': 1},
                                      '2' : {'frags' : 'MostUsedProtoTable_unencrypted',
                                               'pos' : 2},
                                      '3' : {'frags' : 'MostUsedDestinationTable_http',
                                             'pos' : 3},
                                     },
                           'title': tr('Details for HTTP protocol')},
                'top_users_ssl': {'args': {},
                            'filters': 'ip_saddr tcp_dport',
                           'frames': {'0': {'frags': 'MostUsedProtoTable_ssl',
                                            'pos': 0},
                                      '1': {'frags': 'MostUsedUsersTable_ssl',
                                            'pos': 1},
                                      '2' : {'frags' : 'MostUsedProtoTable_encrypted',
                                               'pos' : 2},
                                      '3' : {'frags' : 'MostUsedDestinationTable_ssl',
                                             'pos' : 3},
                                     },
                           'title': tr('Details for SSL protocol')},
                'dropped_sources': {'args': {},
                            'filters': 'ip_saddr proto tcp_dport',
                           'frames': {'0': {'frags': 'LastDroppedConnections',
                                            'pos': 0},
#                                      '1': {'frags': 'HostPortTable',
                                      '1': {'frags': 'HostsOnDportTable_dropped',
                                            'pos': 1},
                                      '2' : {'frags' : 'MostDroppedSourceTable',
                                               'pos' : 2},
                                     },
                           'title': tr('Dropped Sources')},
                'dropped_users': {'args': {},
                            'filters': 'ip_saddr proto tcp_dport',
                           'frames': {'0': {'frags': 'UserTable_most_drop',
                                            'pos': 0},
                                      '1': {'frags': 'UserAppTable_drop',
                                            'pos': 1},
                                      '2' : {'frags' : 'MostDroppedSourceTable',
                                               'pos' : 2},
                                      '3' : {'frags' : 'HostPortTable_drop',
                                             'pos' : 3},
                                     },
                           'title': tr('Dropped Users')},
              },
     'pagesindex': {
                    'general': {'pages': 'main last_dropped_connections',
                                'pos': 0,
                                'title': tr('General')},
                    'protocols': {'pages': 'all_proto encrypted_proto unencrypted_proto classification', #'top_unencrypted top_encrypted top_unknown',
                                'pos': 1,
                                'title': tr('Protocols')},
                    'sources': {'pages': 'top_sources dropped_sources accepted_users top_sources_port80 top_encrypted',
                                'pos': 2,
                                'title': tr('Sources')},
#                    'users': {'pages': 'top_users dropped_users accepted_users', #top_users_http top_users_ssl',
#                                'pos': 2,
#                                'title': tr('Users')},
#                    'classification' : {'pages' : 'classification',
#                                        'pos' : 3,
#                                        'title' : tr('Protocols Classification'),
#                                        },
                    'network_usage' : {'pages' : 'peer2peer audio_video instant_messaging traffic',
                                        'pos' : 4,
                                        'title' : tr('Network Usage'),
                                        },
#                    'system': {'pages': 'cpu',
#                                'pos': 3,
#                                'title': tr('System Sensor Data')},
                    'bookmarks': {'pages': '', 'pos': 5, 'title': tr('Bookmarks')},
                    'history': {'pages': '', 'pos': 6, 'title': tr('History')},
                },
    'reports': {
                'top': {'title':    tr('Top Report'),
                        'filters':  (),
                        'scenario': [('newPage', tr('Activity'), [1, 1]),
#                                     ('append', tr('Dropped packets per day'), 'histo', 'PacketsCountTable', {'state': 0, 'sortby': 'packets'}),
                                     ('append', tr('Dropped packets per day'), 'histo', 'PacketsCountTable', {'state': 0, 'sortby': 'packets'}),
                                     ('append', tr('All packets per day'), 'histo', 'PacketsCountTable', {'sortby': 'packets'}),
                                     #('newPage', tr('Users sessions'), [1]),
                                     #('append', '', 'gantt', 'UsersHistoryTable', {'extra': False, 'limit': 200}),
                                     ('newPage', tr('Users'), [1, 1]),
                                     ('append', tr('Dropped user applications'), 'table', 'UserAppTable', {'state': 0, 'sortby': 'packets'}),
                                     ('append', tr('Accepted user applications'), 'table', 'UserAppTable', {'state': 1, 'sortby': 'packets'}),
                                     ('newPage', tr('Users'), [1, 1]),
                                     ('append', tr('Most dropped users'), 'histo', 'UserTable', {'state': 0, 'sortby': 'packets'}),
                                     ('append', tr('Most accepted users'), 'histo', 'UserTable', {'state': 1, 'sortby': 'packets'}),
                                     ('newPage', tr('Hosts'), [1]),
                                     ('append', tr('Most destination'), 'pie', 'IPdstTable', {'sortby': 'packets'}),
                                     ('newPage', tr('Hosts'), [1, 1]),
                                     ('append', tr('Most dropped hosts'), 'table', 'IPsrcTable', {'state': 0, 'sortby': 'packets'}),
                                     ('append', tr('Most accepted hosts'), 'table', 'IPsrcTable', {'state': 1, 'sortby': 'packets'}),
                                     ('newPage', tr(''), [1]),
                                     ('appendTopOfThePop', 'Top 10 dropped users with their Top 10 ports',
                                                               'UserTable', {'sortby': 'packets', 'limit': 10, 'state': 0}, 'username',
                                                               'TCPTable', {'sortby': 'packets', 'limit': 10, 'state': 0}),
                                    ]
                        },
                'user': {'title':    tr('User Report'),
                         'filters':  ('user_id',),
                         'scenario': [('newPage', tr('Activity'), [1, 1]),
                                      ('append', tr('Dropped packets per day'), 'histo', 'PacketsCountTable', {'state': 0, 'sortby': 'packets'}),
                                      ('append', tr('All packets per day'), 'histo', 'PacketsCountTable', {'sortby': 'packets'}),
                                      ('newPage', tr('Applications'), [1, 1]),
                                      ('append', tr('Dropped applications'), 'table', 'AppTable', {'state': 0, 'sortby': 'packets'}),
                                      ('append', tr('Accepted applications'), 'table', 'AppTable', {'state': 1, 'sortby': 'packets'}),
                                     ]
                        },
               },
    'printer': {}
    }



default_params = {
#                 'proto' : {'ip' : 'tcp udp',
#                    'tcp' : 'http mysql vmware established smtp',
#                    'udp' : 'tftp snmp',
#                    'http' : 'google youtube facebook'
#                            },
                 'family' : {'application' : 'dict epm garp ldap ldaps mq nspi portmap srvloc ssdp syslog',
                             'audio_video' : 'h225 h245 mgcp mms mpegts msn_video paltalk_audio pplive' \
                                             'q931 rdt rtcp rtp rtsp sccp shoutcast sip x25 ymsg_video',
                             'authentication' : 'chap ident krb5 pap radius socks4 socks5 yppasswd ypserv',
                             'compression' : 'ccp comp',
                             'database' : 'mysql postgres tds tns',
                             'erp' : 'sap',
                             'encrypted' : 'ipsec isakmp ocsp ssh ssl',
                             'file_server' : 'cft ftp ftp_data mount netbios nfs nlockmgr rquota rstat rsync' \
                                             'rusers smb sync tftp ypupdate',
                             'file_transfer' : 'aim_transfer jabber_transfer paltalk_transfer ymsg_transfer',
                             'game' : 'cstrike quake steam wow xboxlive',
                             'instant_messaging' : 'aim aim_express aims gadugadu gizmo gmail_chat irc ircs jabber msn' \
                                                   'msnmobile paltalk qq skype ymsg ymsg_conf ymsg_webmessenger',
                             'mail' : 'imap imaps lotusnotes mapi pop3 pop3s smtp smtps',
                             'ms_office' : 'groove',
                             'middleware' : 'amqp dcerpc giop rpc soap',
                             'net_manager' : 'cdp lcp netflow rsvp snmp sonmp tdcollect',
                             'net_service' : '8021q arp atalk cgmp cotp dec dhcp dns dtp eth hpellc icmp icmp6' \
                                             'igmp ip ip6 ipcp ipx ipxsap isl llc loadbalan mcs mipv6 narp nbns' \
                                             'ntp osinl pim rlp rpl sctp sna snap snpp stun tcp tibcordv udp' \
                                             'vines xns xyplex',
                             'non_classified' : 'unknown malformed incomplete established synflood',
                             'groups' : 'google_groups live_groups msn_groups nntp nntps yahoo_groups',
                             'peer2peer' : 'ares bittorrent directconnect edonkey gnutella goboogy imesh kazaa' \
                                           'mute openft pando rtmp slsk thunder winmx zattoo',
                             'printer' : 'cups ipp jetdirect lpr',
                             'qosmos' : 'base qms',
                             'routing' : 'apollo bgp eigrp hsrp ipxrip loop mpls nlsp ospf pwe rip1 rip2' \
                                         'ripng1 stp vrrp',
                             'security' : 'mcafee',
                             'telephony' : 'isup',
                             'terminal' : 'rlogin rsh telnet telnets tnvip',
                             'thin_client' : 'ica pcanywhere rdp rfb wmware x11 vmware',
                             'tunneling' : 'etherip gre gtp ipv6cp l2tp lqr openvpn ppp pppoe pptp vjc_comp'\
                                           'vjc_uncomp xot',
                             'wap' : 'bxml mmse ucp wsp wtls wtp',
                             'web' : '2shared 4shared apple ask avoidr bebo dailymotion deezer' \
                                     'doubleclick_ads ebay ebuddy expedia facebook fileflyer flickr friendster' \
                                     'google google_ads google_earth google_maps gougou hi5 http https' \
                                     'linkedin live megaupload mpquest msn_search myspace netlog' \
                                     'officedepot perfspot pogo rambler rapidshare realtor' \
                                     'runescape secondlife sendspace skyblog skyrock southwest tagged' \
                                     'tchatche travelocity trombi viadeo wikipedia windowslive wordpress' \
                                     'xmlrpc yahoo_answers yahoo_biz yahoo_games yahoo_geocities yahoo_maps' \
                                     'yahoo_realestate yahoo_search yahoo_travel youtube zshare',
                             'webmail' : 'dimp gmail gmail_basic gmail_mobile imp laposte_webmail live_hotmail' \
                                         'livemail_mobile mailru maktoob mimp orangemail owa squirrelmail ymail2' \
                                         'ymail_classic ymail_mobile ymail_mobile_new zimbra zimbra_standard',
                             'web_proxy' : 'bypassthat kproxy megaproxy proxono proxeasy surrogafier vtunnel'
                             },
          'db_association' : {},
         }
