
"""
Copyright (C) 2009-2011 EdenWall Technologies

This file is part of NuFirewall. 
 
 NuFirewall is free software: you can redistribute it and/or modify 
 it under the terms of the GNU General Public License as published by 
 the Free Software Foundation, version 3 of the License. 
 
 NuFirewall is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 GNU General Public License for more details. 
 
 You should have received a copy of the GNU General Public License 
 along with NuFirewall.  If not, see <http://www.gnu.org/licenses/>
"""

from PyQt4.QtCore import SIGNAL

from nudpi.client.qt.args import arg_types
from nudpi.client.qt.widgets.tree_view import TreeView
from nudpi.client.qt.views.nudpi_base import NudpiBaseFragmentView

from nudpi.client.qt.widgets.tree_model import TreeItem

class TreeFragmentView(NudpiBaseFragmentView, TreeView):
    def __init__(self, fetcher, parent):
        TreeView.__init__(self, parent)
        NudpiBaseFragmentView.__init__(self, fetcher)

    def updateData(self, results):
        if self.is_closed:
            return

        self.my_model = None
        if NudpiBaseFragmentView.updateData(self, results):
            self.expandAll()
            self.resizeColumnToContents(0)
            self.delegate.reset()

    def redraw(self):
        self.expandAll()
        self.resizeColumnToContents(0)
        self.delegate.reset()

    def mouseDoubleClickEvent(self, event):
        index = self.indexAt(event.pos())

        if not index.isValid():
            return

        rootitem = self.my_model.rootItem
        column = 0
        header = rootitem.data(column)
        name = self.arg_types[unicode(header)]
        types = arg_types[name]

        if len(types.pagelinks) > 0:
            field = types.pagelinks[0]

            treeitem_name = self.my_model.item(index).data(TreeItem.ITEM_NAME)
            label = unicode(treeitem_name)
            value = label

            self.loadPage(field, label, value, pagename=None)
