
CREATE LANGUAGE plpgsql;

CREATE TABLE proto_defs (
    proto_id integer NOT NULL,
    proto_name text
);

CREATE FUNCTION to_proto(integer) RETURNS text
    LANGUAGE sql
    AS $_$
    SELECT proto_name AS result FROM proto_defs WHERE proto_id = $1;
$_$;

ALTER FUNCTION public.to_proto(integer) OWNER TO dpi;

--
-- dpi table
--
CREATE TABLE dpi (
    id serial NOT NULL,
    t_start bigint,
    t_end bigint,
    ip_saddr_str inet,
    ip_daddr_str inet,
    tcp_dport integer,
    l3_proto integer,
    l4_proto integer,
    l5_proto integer,
    ct_pckts bigint,
    ct_bytes bigint,
    ct_flows bigint,
    proto_path integer[]
);
CREATE INDEX dpi_id ON dpi USING btree (id);
CREATE INDEX dpi_combo ON dpi USING btree (t_start, t_end, ip_saddr_str, tcp_dport);

GRANT ALL ON dpi TO dpi;


CREATE SEQUENCE dpi_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;

GRANT ALL ON dpi_id_seq TO dpi;

--
-- Dropped users table
--
CREATE TABLE dropped_users (
    id serial NOT NULL,
    oob_time_sec integer,
    ip_saddr_str inet,
    ip_daddr_str inet,
    ip_protocol integer,
    tcp_sport integer,
    tcp_dport integer,
    oob_prefix text
);
CREATE INDEX dropped_users_id ON dropped_users USING btree (id);

GRANT ALL ON dropped_users TO dpi;

CREATE SEQUENCE dropped_users_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;

GRANT ALL ON dropped_users_id_seq TO dpi;

