#!/usr/bin/env python
"""
Copyright (C) 2009-2011 EdenWall Technologies

This file is part of NuFirewall. 
 
 NuFirewall is free software: you can redistribute it and/or modify 
 it under the terms of the GNU General Public License as published by 
 the Free Software Foundation, version 3 of the License. 
 
 NuFirewall is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 GNU General Public License for more details. 
 
 You should have received a copy of the GNU General Public License 
 along with NuFirewall.  If not, see <http://www.gnu.org/licenses/>
"""


from imp import load_source
from os import path

CLASSIFIERS = [
    'Intended Audience :: Developers',
    'Development Status :: 4 - Beta',
    'License :: OSI Approved :: GNU General Public License (GPL)',
    'Operating System :: OS Independent',
    'Natural Language :: English',
    'Programming Language :: Python',
]

PACKAGES = (
    'nuface',
    'nuface.common',
    'nuface.iptables',
    'nuface.forward',
    'nuface.forward.resource',
    'nuface.forward.rule',
    'nuface.localfw',
)

def main():
    from distutils.core import setup
    from distutils.command.install import INSTALL_SCHEMES

    # Install scripts (nuface) in /usr/sbin instead of /usr/bin
    INSTALL_SCHEMES['unix_prefix']['scripts'] = '$base/sbin'

    nuface = load_source("version", path.join("nuface", "version.py"))

    long_description = open('README').read() + open('ChangeLog').read()

    setup(
        name=nuface.PACKAGE,
        version=nuface.VERSION,
        url=nuface.WEBSITE,
        download_url=nuface.WEBSITE,
        license=nuface.LICENSE,
        author="Victor Stinner",
        description="Netfilter configuration backend",
        long_description=long_description,
        classifiers=CLASSIFIERS,
        packages=PACKAGES,
        scripts=("scripts/nuface",),
    )

if __name__ == "__main__":
    main()

