
"""
Copyright (C) 2009-2011 EdenWall Technologies

This file is part of NuFirewall. 
 
 NuFirewall is free software: you can redistribute it and/or modify 
 it under the terms of the GNU General Public License as published by 
 the Free Software Foundation, version 3 of the License. 
 
 NuFirewall is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 GNU General Public License for more details. 
 
 You should have received a copy of the GNU General Public License 
 along with NuFirewall.  If not, see <http://www.gnu.org/licenses/>
"""

import sys
from pkg_resources import require
require('PyRRD')
from pyrrd import rrd
from time import time

class RrdInfo():
    """
    Contains informations about RRD file (coordinates)
    """
    def __init__(self, filename = ""):
        self.filename = filename
#         self.data = {"dsName":"", "dsType":"", "rpn":"", "heartbeat":"", "cf":"", "step":""}
        self.rrd_data = rrd.RRD(self.filename, mode = "r")
#         data = self.rrd_data.getData()

    def coords(self, period):
        """
        Get coordinates in a period
        Return dictionnary : key = time, value = load
        """
        endTime = time()
        startTime = endTime - period
        fetch = self.rrd_data.fetch("AVERAGE", start = int(startTime))
        self.__coords = fetch[fetch.keys()[0]]

        times = []
        values = []

        for coord in self.__coords:
            xTime = coord[0]
            yLoad = coord[1]

            if xTime >= startTime and xTime <= endTime:
                if str(yLoad) == "nan":
                    yLoad = 0
                times.append(xTime)
                values.append(yLoad)

        coords = [times, values]
        return coords
#
# if __name__ == "__main__":
#     app = RrdInfo()
#     sys.exit()
