
"""
Copyright (C) 2009-2011 EdenWall Technologies

This file is part of NuFirewall. 
 
 NuFirewall is free software: you can redistribute it and/or modify 
 it under the terms of the GNU General Public License as published by 
 the Free Software Foundation, version 3 of the License. 
 
 NuFirewall is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 GNU General Public License for more details. 
 
 You should have received a copy of the GNU General Public License 
 along with NuFirewall.  If not, see <http://www.gnu.org/licenses/>
"""

import sys
from PyQt4.QtGui import QApplication, QWidget, QHBoxLayout, QVBoxLayout, QScrollArea, QPalette, QComboBox, QSpacerItem, QSizePolicy
from PyQt4.QtCore import SIGNAL, SLOT, Qt

from nucentral.qt.central_window import CentralWindow
from nucentral.qt.central_window import STANDALONE

from rrdlabelwidget import RrdLabelWidget
from rrdview import RrdView

# ************ Test ***************
from nucentral.qt.application import create_nucentral_application

class GraphWindow(CentralWindow):
    ROLES = set(('nugraph_read',))

    def __init__(self, application, client, standalone=False, parent=None, eas_window=None):
        CentralWindow.__init__(self, client, parent, eas_window)
        self.has_nugraph = None
        self.setupCentralWindow(application, standalone)
        self.client = client

        self.ui = RrdView(self, self.client)
        self.setCentralWidget(self.ui)

    def isReadOnly(self):
        return True

# **************** Test ***************
if __name__ == "__main__":

    app, client = create_nucentral_application("nugraph")
#   FIXME: create a locale file (and maybe a resource file)

    window = GraphWindow(app, client, standalone=STANDALONE)
    window.show()
    exit(app.exec_())
