
"""
Copyright (C) 2009-2011 EdenWall Technologies

This file is part of NuFirewall. 
 
 NuFirewall is free software: you can redistribute it and/or modify 
 it under the terms of the GNU General Public License as published by 
 the Free Software Foundation, version 3 of the License. 
 
 NuFirewall is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 GNU General Public License for more details. 
 
 You should have received a copy of the GNU General Public License 
 along with NuFirewall.  If not, see <http://www.gnu.org/licenses/>
"""

from PyQt4.QtGui import QWidget, QPushButton, QHBoxLayout, QSizePolicy
from PyQt4.QtCore import QUuid, QString
import os

from cartesianplot import CartesianPlot

class RrdWidget(QWidget):
    """
    """
    def __init__(self, client, filename, period = 3200, parent = None):
        QWidget.__init__(self, parent)
        self.uuid = str(QUuid.createUuid().toString())

        self.client = client
        coords = self.client.call('nugraph', 'getCoords', period, self.uuid, filename)

        periodString = "HOUR"
        self.graphWidget = CartesianPlot(filename)
        self.graphWidget.times = coords[0]
        self.graphWidget.values = coords[1]
        self.graphWidget.draw(periodString)

        vlayout = QHBoxLayout()
        vlayout.addWidget(self.graphWidget)
        self.setLayout(vlayout)

    def refresh(self, period, periodString):
        coords = self.client.call('nugraph', 'getCoords', period, self.uuid)
        self.graphWidget.times = coords[0]
        self.graphWidget.values = coords[1]
        self.graphWidget.draw(periodString)

    def removeGraph(self):
        self.client.call('nugraph', 'remove', self.uuid)
