
"""
Copyright (C) 2009-2011 EdenWall Technologies

This file is part of NuFirewall. 
 
 NuFirewall is free software: you can redistribute it and/or modify 
 it under the terms of the GNU General Public License as published by 
 the Free Software Foundation, version 3 of the License. 
 
 NuFirewall is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 GNU General Public License for more details. 
 
 You should have received a copy of the GNU General Public License 
 along with NuFirewall.  If not, see <http://www.gnu.org/licenses/>
"""

import sys
import os
from PyQt4.QtGui import QApplication, QWidget, QTreeWidgetItem, QAbstractItemView
from PyQt4.QtCore import QString, SIGNAL

from rrdlabelwidget_ui import Ui_rrdLabelWidget

class RrdLabelWidget(QWidget, Ui_rrdLabelWidget):
    """
    Inherit from QTreeWidget.
    List of RRD files on an OS. We can show graphs of one or many components by clicking on QTreWidget items
    """
    def __init__(self, client, parent = None):
        QWidget.__init__(self, parent)
        self.ui = Ui_rrdLabelWidget()
        self.ui.setupUi(self)
        self.ui.treeWidget.setSelectionMode(QAbstractItemView.MultiSelection)
        self.ui.treeWidget.setHeaderLabel(QString("Sensordata"))
        self.client = client

        # ********************** Server Service *******************
        directories = self.client.call('nugraph', 'getDirsName')

        for directory, subDirs in directories.iteritems():
            item = QTreeWidgetItem(self.ui.treeWidget)
            item.setText(0, directory)
            for subDir in subDirs:
                subItem = QTreeWidgetItem(item)
                subItem.setText(0, subDir)
        # ********************** END Server Service *******************

if __name__ == "__main__":
    app = QApplication(sys.argv)
    widget = RrdLabelWidget()
    widget.show()
    sys.exit(app.exec_())