
"""
Copyright (C) 2009-2011 EdenWall Technologies

This file is part of NuFirewall. 
 
 NuFirewall is free software: you can redistribute it and/or modify 
 it under the terms of the GNU General Public License as published by 
 the Free Software Foundation, version 3 of the License. 
 
 NuFirewall is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 GNU General Public License for more details. 
 
 You should have received a copy of the GNU General Public License 
 along with NuFirewall.  If not, see <http://www.gnu.org/licenses/>
"""

import sys
from PyQt4.QtGui import QApplication, QWidget, QHBoxLayout, QVBoxLayout, QScrollArea, QPalette, QComboBox, QSpacerItem, QSizePolicy, QPushButton
from PyQt4.QtCore import SIGNAL, SLOT, Qt

from rrdlabelwidget import RrdLabelWidget
from graphwidget import GraphWidget

# teest
import PyQt4.Qwt5 as Qwt

class RrdView(QWidget):

    def __init__(self, parent, client):
        QWidget.__init__(self, parent)
        self.rrdLabelWidget = RrdLabelWidget(client)
        self.graphWidget = GraphWidget(client)
        self.combobox = QComboBox()

        # init QComboBox
        comboLabels = ["1 hour range", "24 hours range", "7 days range", "31 days range"]
        self.combobox.addItems(comboLabels)

        # Layout
        hlayout = QHBoxLayout()
        hlayout.addWidget(self.rrdLabelWidget)
        vlayout = QVBoxLayout()
        vlayout.addWidget(self.combobox)
        vlayout.addWidget(self.graphWidget)
        hlayout.addLayout(vlayout, 1)
        self.setLayout(hlayout)


        # *********** Test
#         self.buttonUp = QPushButton()
#         vlayout.addWidget(self.buttonUp)
# #         self.connect(self.buttonUp, SIGNAL("clicked()"), self.graphWidget.itemUp)
#         self.counter = Qwt.QwtCounter(self.buttonUp)
#         self.counter.setRange(0, 10000, 1)
#         self.counter.setNumButtons(3)
#         self.connect(self.counter,
#                      SIGNAL('valueChanged(double)'),
#                      self.graphWidget.go)

        # Connections
        self.connect(self.combobox, SIGNAL("activated(QString)"), self.graphWidget.timeRangeChange)
        self.connect(self.rrdLabelWidget.ui.treeWidget, SIGNAL("itemClicked (QTreeWidgetItem *, int)"), self.graphWidget.itemClickedSlot)

if __name__ == "__main__":
    app = QApplication(sys.argv)
    widget = RrdView()
    widget.show()
    sys.exit(app.exec_())
