from sys import exit

from nucentral.client import NuCentralError
from nucentral.common import tr
from nucentral.qt.central_window import STANDALONE

SUPPORTED_VERSIONS = ("3.0-1", "3.0-2", "3.0-3")
CLIENT_VERSION = "3.0-3"

class Compatibility:
    def __init__(self, main_window, client):
        self.client = client
        self.main_window = main_window
        self.getVersions()
        self.getFeatures()

    def getVersions(self):
        self.client_version = CLIENT_VERSION
        self._nulogVersion()
        self._reportingVersion()

    def _nulogVersion(self):
        client_attr = {
            'version': self.client_version,
        }
        try:
            server_attr = self.client.call("nulog", "setupClient", client_attr)
        except NuCentralError, err:
            try:
                self.nulog_server_version = self.client.call('nulog','getComponentVersion')
            except NuCentralError, err:
                self.main_window.error(
                    tr("Log backend not found! Exiting."),
                    dialog=(self.main_window.standalone == STANDALONE))
                exit(1)

                if not self.client.call('acl', 'check', 'nulog', 'table'):
                    exit(1)

                self.main_window.use_edenwall = self.client.call('CORE', 'useEdenWall')
        else:
            self.nulog_server_version = server_attr['version']

    def _reportingVersion(self):
        try:
            self.reporting_server_version = self.client.call('reporting', 'getComponentVersion')
        except NuCentralError, err:
                self.main_window.error(
                    tr("Log backend not found! Exiting."),
                    dialog=(self.main_window.standalone == STANDALONE))
                exit(1)


    def getFeatures(self):
        self.input_packet_frag = True
        self.csvexport_all = True
        self.authfail = True
        self.print_enterprise = True
        self.user_id = False

        if self.nulog_server_version < '3.0-3':
            self.user_id = True

        if self.nulog_server_version == "3.0-1":
            self.input_packet_frag = False
            self.csvexport_all = False
            self.authfail = False

        if self.reporting_server_version == "3.0-1":
            self.print_enterprise = False


