
"""
Copyright (C) 2009-2011 EdenWall Technologies

This file is part of NuFirewall. 
 
 NuFirewall is free software: you can redistribute it and/or modify 
 it under the terms of the GNU General Public License as published by 
 the Free Software Foundation, version 3 of the License. 
 
 NuFirewall is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 GNU General Public License for more details. 
 
 You should have received a copy of the GNU General Public License 
 along with NuFirewall.  If not, see <http://www.gnu.org/licenses/>
"""

from datetime import datetime, timedelta
from nucentral.common.namedlist import namedlist
from nucentral.common.timezone import UTC

MIN_DATE = datetime(1950, 1, 1, 0, 0, 0, tzinfo=UTC)
MAX_DATE = datetime(2049, 12, 31, 23, 59, 59, tzinfo=UTC)
DEFAULT_PKI_EXPIRE = timedelta(days=3650)
DEFAULT_CERT_EXPIRE = timedelta(days=3650)
CERT_RENEW_ENDTIME = timedelta(days=365)

PKI = namedlist('PKI',
    'id', 'name',
    'organization_unit', 'organization', 'location', 'state', 'country',
    'last_serial')

# nupki < 4.0.2 used PKISettings with fields:
# orgunit, organization, location, state, country

Certificate = namedlist('Certificate',
    'type', 'id', 'cname', 'email', 'organization_unit',
    'location', 'state', 'country', 'status',
    # following fields were added in nupki 4.0.2
    'new_status', 'organization', 'start_date', 'end_date',
    # following fields were added in nupki 4.0.3
    'pki_name',
)

