# Any PKI name, including hidden PKI (starting with "_")
PKI_NAME_REGEX = u"^[a-zA-Z0-9_]+$"

# Public PKI name: don't start with "_"
PUBLIC_PKI_NAME_REGEX = u"^[a-zA-Z0-9][a-zA-Z0-9_]*$"

# Regex matching organization unit and location
ORGANIZATION_UNIT_REGEX = u"^[\x20-\x7e]{0,64}$"

# Regex matching state and organization
STATE_REGEX = u"^[\x20-\x7e]{1,64}$"

# CN is a PrintableString (RFC 2459)
CN_NAME_REGEX = u"^[a-zA-Z0-9 '()+,./:=?-]{1,64}$"

EMAIL_REGEX = u"^[\x00-\x7f]{0,40}$"

# At least two characters
COUNTRY_REGEX = u"^[a-zA-Z]{2}$"

#--- Old versions of nupki --------------------

OLD_ORGANIZATION_UNIT_REGEX = u"^[a-zA-Z]{0,64}$"
OLD_STATE_REGEX = u"^[a-zA-Z]{1,64}$"
OLD_EMAIL_REGEX = u"^[a-zA-Z0-9._@-]{0,40}$"

