#!/usr/bin/python
"""
Copyright (C) 2009-2011 EdenWall Technologies
Written by Sebastien Tricaud <stricaud AT inl.fr>

This file is part of NuFirewall. 
 
 NuFirewall is free software: you can redistribute it and/or modify 
 it under the terms of the GNU General Public License as published by 
 the Free Software Foundation, version 3 of the License. 
 
 NuFirewall is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 GNU General Public License for more details. 
 
 You should have received a copy of the GNU General Public License 
 along with NuFirewall.  If not, see <http://www.gnu.org/licenses/>

$Id: OpenSSLWrapper.py 8983 2009-06-15 08:25:30Z toady $
"""

class NupkiEnv:
    def __init__(self):
        constant = {}

        constant['user-prefix'] = "client-"
        constant['server-prefix'] = "server-"

        constant['cert-suffix'] = ".cert"
        constant['privatekey-suffix'] = ".pkey"
        constant['signreq-suffix'] = ".csr"

        constant['ca-cert'] = "ca.crt"
        constant['ca-privatekey'] = "ca.key"
        constant['ca-signreq'] = "ca.csr"
        constant['cadays'] = "1825"

        self.constant = constant

    def getPrefixFromType(self, type):
        if type == "client":
            return self.constant['user-prefix']
        if type == "server":
            return self.constant['server-prefix']

if __name__ == "__main__":
    nupkienv = NupkiEnv()
    print nupkienv.getPrefixFromType("client")
