from nucentral.client import NuCentralError

class UserSettings:

    DEFAULT_CONFIG = {'current_pki' : '',
                      }

    def __init__(self, main_window):
        self.main_window = main_window
        self.client = main_window.client

        self.load()

    def __getitem__(self, key):
        try:
            return self._settings[key]
        except Exception, err:
            try:
                return self.DEFAULT_CONFIG[key]
            # no configuration corresponding to key
            except Exception, err:
                pass
            return None

    def __setitem__(self, key, value):
        self._settings[key] = value

    def load(self):
        try:
            self._settings = self.client.call('users_config', 'get', 'nupki-qt')
        except Exception, err:
            self._settings = self.DEFAULT_CONFIG

    def save(self):
        try:
            self.client.call('users_config', 'delete', 'nupki-qt')
        except NuCentralError:
        # there isn't any configuration yet
            pass

        current_pki = self['current_pki'] if self['current_pki'] else ''

        params = {'current_pki' : current_pki}
        self.client.call('users_config', 'set', 'nupki-qt', params)