#!/usr/bin/env python
"""
Copyright (C) 2009-2011 EdenWall Technologies

This file is part of NuFirewall. 
 
 NuFirewall is free software: you can redistribute it and/or modify 
 it under the terms of the GNU General Public License as published by 
 the Free Software Foundation, version 3 of the License. 
 
 NuFirewall is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 GNU General Public License for more details. 
 
 You should have received a copy of the GNU General Public License 
 along with NuFirewall.  If not, see <http://www.gnu.org/licenses/>
"""


from imp import load_source
from os import path
from shutil import rmtree

CLASSIFIERS = [
    'Intended Audience :: Developers',
    'Development Status :: 4 - Beta',
    'License :: OSI Approved :: GNU General Public License (GPL)',
    'Operating System :: OS Independent',
    'Natural Language :: English',
    'Programming Language :: Python',
]

PACKAGES = (
    'nupki.qt', 'nupki.qt.ui',
)

def main():
    from distutils.core import setup

    nupki = load_source("version", path.join("nupki", "version.py"))

    long_description = open('README').read()

    if path.exists("build"):
        rmtree("build")

    setup(
        name=nupki.PACKAGE,
        version=nupki.VERSION,
        url=nupki.WEBSITE,
        download_url=nupki.WEBSITE,
        license=nupki.LICENSE,
        author="Sebastien Tricaud",
        description="Manage a PKI (NuCentral client)",
        long_description=long_description,
        classifiers=CLASSIFIERS,
        packages=PACKAGES,
        scripts=("nupki-qt",),
    )

if __name__ == "__main__":
    main()

