#!/usr/bin/python
"""
Copyright (C) 2009-2011 EdenWall Technologies

This file is part of NuFirewall. 
 
 NuFirewall is free software: you can redistribute it and/or modify 
 it under the terms of the GNU General Public License as published by 
 the Free Software Foundation, version 3 of the License. 
 
 NuFirewall is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 GNU General Public License for more details. 
 
 You should have received a copy of the GNU General Public License 
 along with NuFirewall.  If not, see <http://www.gnu.org/licenses/>
"""


from nucentral_client import Application
from pki import PKI

class DummyComponent:
    def __init__(self):
        return

class MyTest(Application):
    def main(self):
        try:
            self.keep_alive.start()
            self.pki = PKI(self.client)
            self.pki.loadPki()
            print self.pki.loadServerCertsPaths('server-cert')
            print self.pki.getServerCertsPaths('server-cert')
            req = self.client.call('nupki', 'getCertRequest', 'client-cert', 'client')
            print req
            print self.pki.signCertRequest('\n'.join(req), 'client-cert')
            print self.pki.getSignedCert('client-cert')

        except Exception, e:
            print e
            self.keep_alive.stop()
            self.client.quit()
            exit(1)

        self.keep_alive.stop()
        self.client.quit()

def main():
    app = MyTest()
    app.main()

if __name__ == "__main__":
    main()




