#coding: utf-8
"""
$Id$


Copyright (C) 2009-2011 EdenWall Technologies

This file is part of NuFirewall. 
 
 NuFirewall is free software: you can redistribute it and/or modify 
 it under the terms of the GNU General Public License as published by 
 the Free Software Foundation, version 3 of the License. 
 
 NuFirewall is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 GNU General Public License for more details. 
 
 You should have received a copy of the GNU General Public License 
 along with NuFirewall.  If not, see <http://www.gnu.org/licenses/>
"""


from nucentral.common.error import NURESTORE
from nucentral.backend import ComponentError

#Component error codes
FORBIDDEN_FILENAME=1
INVALID_ARCHIVE=2
INVALID_USAGE=3

class NurestoreException(ComponentError):
    def __init__(self, error, *args, **kw):
        ComponentError.__init__(self, NURESTORE, NURESTORE, error, *args, **kw)

class ForbiddenFilename(NurestoreException):
    def __init__(self, *args, **kw):
        NurestoreException.__init__(self, FORBIDDEN_FILENAME, *args, **kw)

class InvalidArchive(NurestoreException):
    def __init__(self, *args, **kw):
        NurestoreException.__init__(self, INVALID_ARCHIVE, *args, **kw)

class InvalidUsage(NurestoreException):
    def __init__(self, *args, **kw):
        NurestoreException.__init__(self, INVALID_USAGE, *args, **kw)
