#!/bin/sh

set -e

CN=$1

cat > server.cnf << EOF
[ req ]
default_bits                    = 1024
distinguished_name              = $CN
string_mask                     = nombstr
req_extensions                  = v3_req
input_password                  = secret
output_password                 = secret
[ $CN ]
countryName			        = Country Name (2 letter code)
countryName_default		    = FR
countryName_min			    = 2
countryName_max			    = 2
stateOrProvinceName		    = State or Province Name (full name)
stateOrProvinceName_default	= France

#localityName			    = Locality Name (eg, city)
#localityName_default		= Paris

0.organizationName		    = Organization Name (eg, company)
0.organizationName_default	= INL

organizationalUnitName		= Organizational Unit Name (eg, section)
organizationalUnitName_default	= test_$CUSTOM_OU

commonName			        = Common Name (eg, YOUR name)
commonName_max			    = 64
commonName_value            = $CN

emailAddress			= Email Address
emailAddress_max		= 64
emailAddress_value              = ad@to.fr

[ v3_req ]
nsCertType                      = server
basicConstraints                = critical,CA:false
# PKIX recommendations harmless if included in all certificates.
subjectKeyIdentifier            = hash
# do *not* include email address in subject name (CN field)
subjectAltName                   = DNS:$1,DNS:blah1,DNS:blah2
EOF
