from templateCertTest import TestCert
from sys import exit
import os
import re
import sys

dic = { "vvvcvcv":"[valid] certs signed by CA",
        "vvvcvsv":"[valid] user cert signed by CA, server cert signed by subCA",

        "avvcvcv":"not valid anymore ca",
        "ovvcvcv":"not yet valid ca",

        "vavcvcv":"[valid] not valid anymore subca, certs signed by CA",
        "vovcvcv":"[valid] not yet valid subca, certs signed by CA",
        "vrvcvcv":"[valid] revoked subca, certs signed by CA",

        "vavsvcv":"not valid anymore subca, user cert signed by subCA, server cert signed by CA",
        "vovcvsv":"not yet valid subca, user cert signed by CA, server cert signed by subCA",
        "vrvsvcv":"revoked subca, user cert signed by subCA, server cert signed by CA",

        "vvocvcv":"not valid anymore user cert",
        "vvacvcv":"not yet valid user cert",
        "vvrcvcv":"revoked user cert",

        "vvvcacv":"not valid anymore server cert",
        "vvvcocv":"not yet valid server cert",
        "vvvcrcv":"revoked server cert",

        "vvvcvca":"[valid] not valid anymore crl, no certs revoked",
        "vvvcvco":"[valid] not yet valid crl, no certs revoked",
        "vvrcvca":"[valid] not valid anymore crl, user cert revoked",
        "vvvcrco":"[valid] not yet valid crl, server cert revoked"
}

CURDIR=os.path.dirname(os.path.abspath(sys.argv[0]))

def testConditions():
    cur_dir_list = os.listdir(os.path.curdir)
    for case in dic.keys():
        if case not in cur_dir_list:
            print "We need %s directory for this test"%case
            return False
    return True

def testNormal(tester):
    print "Normal Test"
    GLOBAL_SUCCEED = True
    for case in dic.keys():
        result=tester.run_test(CURDIR+"\\"+case,
                               manual=False,
                               fqdn_check=False,
                               strict_cert=True,
                               user_crl=True,
                               server_crl=True)
        if "[valid]" in dic[case]:
            expected="succeed"
        else:
            expected="fail"

        if result!=expected:
            print "Oh noz ! Itz faild. Testing [%s]:\"%s\", we encountered a '%s' while expecting '%s'." %(case,dic[case], result, expected)
            GLOBAL_SUCCEED = False
    print "______________________"
    return GLOBAL_SUCCEED

def testNoServerCRL(tester):
    print "No Server CRL Test"
    GLOBAL_SUCCEED = True
    for case in dic.keys():
        result=tester.run_test(CURDIR+"\\"+case,
                               manual=False,
                               fqdn_check=False,
                               strict_cert=True,
                               user_crl=True,
                               server_crl=False)

        if "[valid]" in dic[case]:
            expected = "succeed"
        else:
            if case[3] == 'r' and (re.match('vvr[cs]v[cs]v',case)
                                   or re.match('v.rcvcv',case)):
                expected = "succeed"
            else:
                expected = "fail"

        if result!=expected:
            print "Oh noz ! Itz faild. Testing [%s]:\"%s\", we encountered a '%s' while expecting '%s'." %(case,dic[case], result, expected)
            GLOBAL_SUCCEED = False
    print "______________________"
    return GLOBAL_SUCCEED


if __name__ == "__main__":
    print "Checking test conditions"
    if not testConditions():
        exit(1)
    print "We have test conditions, ready for take off."
    tester=TestCert()

    if testNormal(tester) and testNoServerCRL(tester):
        exit(0)
    else:
        exit(1)
