
"""
Copyright (C) 2009-2011 EdenWall Technologies

This file is part of NuFirewall. 
 
 NuFirewall is free software: you can redistribute it and/or modify 
 it under the terms of the GNU General Public License as published by 
 the Free Software Foundation, version 3 of the License. 
 
 NuFirewall is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 GNU General Public License for more details. 
 
 You should have received a copy of the GNU General Public License 
 along with NuFirewall.  If not, see <http://www.gnu.org/licenses/>
"""

from os import listdir
import re
from subprocess import Popen,PIPE
from os import mkdir
from os.path import isdir
import pickle
from ConfigParser import ConfigParser
#from pprint import pprint

class testbot:
    test_directory = "/root/autotests/"
    results_directory = "/root/tests_results/"

    @classmethod
    def read_conf (cls):
        conf = ConfigParser()
        res=conf.read('autotest.conf')
        if res != []:
            cls.results_directory=conf.get('paths', 'results')

    @classmethod
    def load_dic (cls):
        dic={}
        try:
            fd=open("dic.dump",'rb')
            dic=pickle.load(fd)
            fd.close()
        except:
            pass
        return dic

    @classmethod
    def setup (cls):
        if not isdir(cls.results_directory):
            mkdir(cls.results_directory)
            print "results_directory created"

    @classmethod
    def save_dic (cls,dic):
        fd=open("dic.dump",'wb')
        pickle.dump(dic,fd)
        fd.close()

    @classmethod
    def svn_up (cls):
#        process = Popen("svn up", shell=True, stdout=PIPE)
#        test_build = process.stdout.read().rstrip().split("vision ")[1].split(".")[0]
#        return test_build
        return str(1)

    @classmethod
    def aptitude_upgrade(cls):
        command = "dpkg -l | grep nulog | sed 's/.*svn//' | sed 's/-.*//'"
        process = Popen(command, shell=True, stdout=PIPE)
        src_build = process.stdout.read().rstrip()

        return src_build

    @classmethod
    def current_builds(cls):
        return (cls.svn_up(), cls.aptitude_upgrade())

    @classmethod
    def run_tests (cls, sub_dic, current_test_build, current_src_build):
        if not isdir(cls.results_directory+str(current_test_build)):
            mkdir(cls.results_directory+str(current_test_build))

        builddir=cls.results_directory+str(current_test_build)+"/"+current_src_build+"/"
        if not isdir(builddir):
           mkdir(builddir)

        pattern = re.compile("test.*\.py$")
        list_dir = listdir(cls.test_directory)
        list_dir.sort()
        for testfilename in list_dir:
            if pattern.match(testfilename):
                sub_dic[testfilename] = {}

                command = "py.test %s -v" % testfilename
                print command
                process = Popen(command , shell=True, stdout=PIPE)
                retcode = process.poll()
                test_out= process.stdout.readlines()
                process.wait()

                all_explanations = {}
                fail_explanation = False
                results = ""
                subtests=[]
                subtest=""
                testname="T"+testfilename[1:].split(".py")[0]
                #print "let's parse"
                for line in test_out:
#                    print line.rstrip()
                    # Here we match the beginning of py.test tracebacks
                    if "entrypoint" in line:
                        if fail_explanation != False:
                            all_explanations[subtest] = fail_explanation
                        subtest = "test_"+line.split(".test_")[1].split(" ")[0]
                        fail_explanation = []
                        continue
                    # Here we match : testpython.py[5] FAIL, to get the "FAIL" part
                    elif testname+"()" in line and "___________" not in line:
                        subtest_result = "test_"+line.split(".test_")[1].split(" (")[0]
                        subtest_result = subtest_result.split(" ")
                        subtests.append(subtest_result)
#                        print subtest_result
                        continue
                    # We record every line of the py.test tracebacks
                    if fail_explanation != False:
                        fail_explanation.append(line)

                if fail_explanation != False:
                    all_explanations[subtest] = fail_explanation

                explanation_index=0
                index=0

                if not isdir(builddir+testfilename):
                    mkdir(builddir+testfilename)

                for subtest in subtests:
                    if subtest[1] == "FAIL":
                        output_name = builddir+testfilename+"/"+\
                                    subtest[0].rstrip()+".html"
                        fd=open(output_name,'w')
                        for line in all_explanations[subtest[0]]:
                            line=line.replace(' ',"&nbsp;").replace("\n","<br>\n")
                            if "copied&nbsp;in" in line:
                                post_mortem_file=line.split(cls.results_directory)[1][:-5]
                                tab_res=[subtest[1],post_mortem_file]
                                replacement = "<a href=\"%s\"> %s%s </a>" % (post_mortem_file,cls.results_directory,post_mortem_file)
                                line=line.replace(cls.results_directory+post_mortem_file,replacement)
                            fd.write(line)
                        explanation_index+=1
                        fd.close()

                    sub_dic[testfilename][subtest[0]] = subtest[1]
                    index+=1

    @classmethod
    def dic2html(cls, dic, filename):
        results_file = open (cls.results_directory+filename,'w')
        results_file.write("<body link=white vlink=white>\n")

        test_builds = dic.keys()
        test_builds.sort()
        test_builds.reverse()
        for test_build in test_builds:
            results_file.write("Tests automatis&eacute;s, version %s" % test_build)
            results_file.write("<table border=1 cellspacing=0>\n")
            results_file.write("    <tr>\n")
            results_file.write("        <th align=center> Test name </th>\n")

            testclasses=[]
            src_builds = dic[test_build].keys()
            src_builds.sort()
            src_builds.reverse()
            for src_build in src_builds:
                results_file.write("        <th align=center> %s </th>\n" % src_build)
                testclasses = dic[test_build][src_build].keys()

            results_file.write("    </tr>\n")

            test_classes = testclasses
            test_classes.sort()
            for testclass in test_classes:
                results_file.write("    <tr><td colspan=%s bgcolor=darkgray>  </td></tr>\n" % (str(len(dic[test_build].keys())+1)))
                results_file.write("    <tr><th align=right valign=top> %s </th>\n" % (testclass))

                sub_tests = dic[test_build][src_build][testclass].keys()
                sub_tests.sort()

                for this_build in src_builds:
                    onefail=False
                    for subtest in sub_tests:
                        if dic[test_build][src_build][testclass][subtest] == "FAIL":
                            onefail=True
                            break

                    results_file.write ("<!-- %s -->       <td align=center bgcolor=" % this_build)
                    if not onefail:
                        results_file.write("limegreen>.</td>\n")
                    else:
                        results_file.write("red><a href=\"/%s/%s/%s/results.html\">F</a></td>\n" % (test_build, this_build, testclass))
                results_file.write("    </tr>\n")

                subtest_file = open("%s/%s/%s/%s/results.html" % (cls.results_directory, test_build, this_build, testclass),'w')
                subtest_file.write("<body link=white vlink=white>\n")
                subtest_file.write("Tests automatis&eacute;s, version %s, classe %s, EdenOS svn%s" % (test_build,testclass, this_build))
                subtest_file.write("<table border=1 cellspacing=0>\n")
                subtest_file.write("    <tr>\n")
                subtest_file.write("        <th align=center> Subtest </th>\n")
                subtest_file.write("        <th align=center> Results </th>\n")
                for subtestname in sub_tests:
                    subtest_file.write("    <tr>\n")
                    subtest_file.write("       <th align=center> %s </th>\n" % subtestname)
                    for this_build in src_builds:
                        subtest_file.write ("<!-- %s -->       <td align=center bgcolor=" % this_build)
                        if dic[test_build][src_build][testclass][subtestname] == "ok":
                            subtest_file.write("limegreen>.</td>\n")
                        else:
                            subtest_file.write("red><a href=\"/%s/%s/%s/%s.html\">F</a></td>\n" % (test_build, this_build, testclass,subtestname))
                    subtest_file.write ("    </tr>\n")
                subtest_file.write ("</table>\n")
                subtest_file.write ("</body>\n")
                subtest_file.close()

            results_file.write ("</table>\n")
        results_file.write ("</body>\n")

        results_file.close ()

dic = testbot.load_dic()
testbot.read_conf()
ret = testbot.setup()
if dic != {}:
    test_builds = dic.keys()
    test_builds.sort()
    last_test_build = test_builds[-1]

    src_builds = dic[last_test_build].keys()
    src_builds.sort()
    last_src_build = src_builds[-1]

(current_test_build, current_src_build) = testbot.current_builds ()

if dic == {} or (current_test_build, current_src_build) != (last_test_build, last_src_build):
    if dic != {}:
        if current_test_build != last_test_build:
            dic[current_test_build] = {}
        if current_src_build != last_src_build:
            dic[current_test_build][current_src_build]={}
    else:
        dic[current_test_build]={}
        dic[current_test_build][current_src_build]={}

    sub_dic = dic[current_test_build][current_src_build]
    testbot.run_tests(sub_dic, current_test_build, current_src_build)
if dic != {}:
    testbot.dic2html(dic,"results.html")
testbot.save_dic(dic)
