
#coding: utf-8
"""
Copyright (C) 2009-2011 EdenWall Technologies
Written by Julien Miotte <jmiotte AT edenwall.com>
$Id:$
"""

from templateTest import Test

class TestQuick(Test):
    def test_conntrack_correctly_written(self):
        """
            Test motivated by pollux
        """
        filename = "/etc/conntrackd/conntrackd.conf"
        expected = ("\n\s*LogFile off", "\n\s*Syslog off")
        self.correctly_written(filename, expected)

    def test_sysctl_conf_correctly_written(self):
        """
        Test motivated by #1560
        """
        print self.results_path
        filename = "/etc/sysctl.d/nf_conntrack_max.conf"
        expected = ("net.netfilter.nf_conntrack_max = 4000000",)
        self.correctly_written(filename, expected)

    def test_nucentral_conf_audit_correctly_written(self):
        """
            Test motivated by #1734
        """
        filename = "/etc/nucentral/nucentral.conf"
        expected = ("[audit]",
                    "db_url = postgres://edenaudit:1234@localhost/edenaudit",
                    "db_create_tables = False")
        self.correctly_written(filename, expected)

#    def test_logrotate(self):
#        """
#            Test motivated by acatout and #2997
#        """
#        command = "logrotate -d -v /etc/logrotate.conf 2>&1 |grep ^error:"
#        self.output_check(command, ("error",), should_find=False)

if __name__ == "__main__":
    my_test = TestQuick()
    my_test.setup_class()
#    my_test.test_conntrack_correctly_written()
    my_test.test_sysctl_conf_correctly_written()
    my_test.test_nucentral_conf_audit_correctly_written()
#    my_test.test_logrotate()
    my_test.teardown_class()
