#!/usr/bin/env python
from nucentral.client.nucentral_client_base import NuCentralClientBase
import subprocess
import os

def get_beversion():
    handle = subprocess.Popen(
                                "ps aux | grep edenwall-administration-suite",
                                shell=True,
                                stdout=subprocess.PIPE,
                                stderr=subprocess.PIPE
    )
    eas_list = handle.stdout.readlines()
    eas_ips = []
    for eas in eas_list:
        if "--host " in eas:
            eas_ips.append(eas.split("--host ")[1].rstrip())

    for ip in eas_ips:
        client = NuCentralClientBase(
                                protocol="https",
                                host=ip,
                                ssl_config=None
        )
        client.authenticate("admin", "admin")
        history = client.call('update', 'history')
        highest = client.call('update', 'getHighestApplied')
        history.reverse()

        beversion = None

        for update in history:
            if update[1] == highest:
                beversion = ip, str(update[1]), update[3].split(" EdenOS update.")[0]
                break

        yield beversion

if __name__ == "__main__":
    if not os.path.exists("/usr/bin/notify-send"):
        print "You should install libnotify-bin."
        os.exit(1)

    for beversion in get_beversion():
        if beversion:
            subprocess.Popen(
                """notify-send "Backend %s" "Update %s %s" """ %
                                        (beversion[0], beversion[1], beversion[2]),
                shell=True,
            )
            print """Update %s %s (Backend %s)""" % \
                                        (beversion[1], beversion[2], beversion[0])
