#!/usr/bin/python

"""
Copyright (C) 2010-2011 EdenWall Technologies

This file is part of NuFirewall. 
 
 NuFirewall is free software: you can redistribute it and/or modify 
 it under the terms of the GNU General Public License as published by 
 the Free Software Foundation, version 3 of the License. 
 
 NuFirewall is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 GNU General Public License for more details. 
 
 You should have received a copy of the GNU General Public License 
 along with NuFirewall.  If not, see <http://www.gnu.org/licenses/>
"""


from __future__ import with_statement
from copy import deepcopy
import sys
from IPy import IP

from nucentral.client.nucentral_client_base import NuCentralClientBase
from replay_and_apply import apply_and_wait
from replay import replay


def getNetConfig(host):
    client = NuCentralClientBase(host=host)
    client.call('session', 'authenticate', 'admin', 'admin')
    conf = client.call('network', 'getNetconfig')
    client.call('session', 'destroy')
    return conf

def setNetConfig(host, conf):
    client = NuCentralClientBase(host=host)
    client.call('session', 'authenticate', 'admin', 'admin')
    conf = client.call('network', 'setNetconfig', conf)
    client.call('session', 'destroy')
    return conf

if __name__ == '__main__':
    from optparse import OptionParser
    usage = "Usage: %prog [options] host record_file [record_file...]"
    parser = OptionParser(usage=usage)
    parser.add_option("-v", "--verbose", action="store_true", default=False,
                      help="Print calls and results")
    (options, args) = parser.parse_args()
    if len(args) < 2:
        parser.error("Please specify host and record file(s).")

    # Backup the current network configuration
    conf = getNetConfig(args[0])

    from socket import gethostbyname
    vars = {
        '__host__' : gethostbyname(args[0]),
        '__net__' : str( IP( gethostbyname(args[0]) ).make_net(24) ),
        '__netconf__' :deepcopy(conf),
    }

    print vars
    print "starting", args[1]
    f = open(args[1])
    exec(f.read(), vars)
    replay(args[0], vars['recorded_calls'], True)

    status = apply_and_wait(args[0])

    if status:
        print "There was an error while while performing the test"

    sys.exit(status)
