#!/usr/bin/python

"""
Copyright (C) 2010-2011 EdenWall Technologies

This file is part of NuFirewall. 
 
 NuFirewall is free software: you can redistribute it and/or modify 
 it under the terms of the GNU General Public License as published by 
 the Free Software Foundation, version 3 of the License. 
 
 NuFirewall is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 GNU General Public License for more details. 
 
 You should have received a copy of the GNU General Public License 
 along with NuFirewall.  If not, see <http://www.gnu.org/licenses/>
"""


from __future__ import with_statement
from sys import argv
from base64 import b64decode

from nucentral.client.error import NuCentralError
from nucentral.client.nucentral_client_base import NuCentralClientBase


if __name__ == '__main__':
    if len(argv) != 6:
        print "Syntax: get_cert.py <nucentral ip> <pki_name> <certificate_name> <certificate_type> <output zip file>"
        exit(1)
    try:
        client = NuCentralClientBase(host=argv[1])
        client.call('session', 'authenticate', 'admin', 'admin')
        zip = client.call('nupki', 'getZIPCert', argv[2], argv[3], argv[4])
        zip = b64decode(zip)
        f = open(argv[5], 'wb')
        f.write(zip)
        f.close()
    except NuCentralError:
        pkis = client.call('nupki', 'listPKI')

        for pki in pkis:
            print "PKI name:", pki[1]
            print "Server certs:", client.call('nupki', 'listServerCerts', pki[1])
            print "Client certs:", client.call('nupki', 'listServerCerts', pki[1])
        else:
            print "No pki found"

        raise
