#!/usr/bin/python

"""
Copyright (C) 2010-2011 EdenWall Technologies

This file is part of NuFirewall. 
 
 NuFirewall is free software: you can redistribute it and/or modify 
 it under the terms of the GNU General Public License as published by 
 the Free Software Foundation, version 3 of the License. 
 
 NuFirewall is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 GNU General Public License for more details. 
 
 You should have received a copy of the GNU General Public License 
 along with NuFirewall.  If not, see <http://www.gnu.org/licenses/>
"""


from __future__ import with_statement
import sys
from time import sleep
from IPy import IP

from nucentral.client.nucentral_client_base import NuCentralClientBase
from replay import replay_record_files

def apply_and_wait(host):
    print "starting apply"
    client = NuCentralClientBase(host=host)
    client.call('session', 'authenticate', 'admin', 'admin')
    client.call('config', 'applyStart')

    status = 0
    index = 0
    done = False
    while not done:
        lst = client.call('config', 'applyLog', index)

        for msg in lst:
            print msg
            if msg[2] == 'global completed':
                done = True
                break

            if msg[1] == 'application error':
                status = 1

        index += len(lst)

        sleep(1)
        print "waiting"
    client.call('session', 'destroy')
    return status

if __name__ == '__main__':
    from optparse import OptionParser
    usage = "Usage: %prog [options] host record_file [record_file...]"
    parser = OptionParser(usage=usage)
    parser.add_option("-v", "--verbose", action="store_true", default=False,
                      help="Print calls and results")
    (options, args) = parser.parse_args()
    if len(args) < 2:
        parser.error("Please specify host and record file(s).")

    replay_record_files(args[1:], args[0], options)

    status = apply_and_wait(args[0])
    if status:
        print "There was an error while applying the configuration"
    sys.exit(status)
