#!/bin/bash
if [ "$#" != 2 ] && [ "$#" != 3 ]
then
	echo "Syntax: $0 <config file> <test directory> [test name]" >&2
	exit 1
fi


source "$1"

export TEST_IP
export TEST_MASTER
export TEST_NETWORK
export TEST_NETWORK2
export TEST_IP2A
export TEST_IP2B
export TEST_IP2C
export TEST_IP2GW
export TEST_PARENT_PROXY
export TEST_URL
export TEST_DST_NETWORK
export TEST_DST_HOST
export TEST_SRC_HOST_VIA_SSH

export PYTHONPATH=$PYTHONPATH:../../../nucentral:../../replay:..
export TEST_NUCENTRAL_IP=$TEST_IP

res=0
cd $2
if [ "$3" != "" ]
then
	test_list=$3.check
else
	test_list=*.check
fi

for file in $test_list
do
	echo "Starting ${file//.check/}"

	# Configuration commands
	if [ -e ./${file//.check/.config} ]
	then
		# Use custom configuration command if it exists
		# otherwise just start edw xml-rpc commands
		./${file//.check/.config}
	else
		../replay_and_apply.py $TEST_NUCENTRAL_IP -v ${file//.check/.edw}
	fi
	res=$(($res|$?))

	# Perform the check
	./${file}
	res=$(($res|$?))

	echo
	echo
done

exit $res
