#!/bin/bash
set -e
source "$1"

if [ $# !=  1 ]
then
	echo "Syntaxe: $0 [configuration file]" > /dev/stderr
	exit 1
fi

echo "Configuring secondary"

export TEST_HA_IFACE
export TEST_NETWORK
export TEST_IP
export TEST_IP_PRIMARY
export TEST_IP_SECONDARY

export PYTHONPATH=$PYTHONPATH:../../nucentral:../replay:.

# Configure console access
./replay_and_apply.py -v $TEST_IP_PRIMARY console/simple_console.edw
./replay_and_apply.py -v $TEST_IP_SECONDARY console/simple_console.edw

# Configure snmp access
./replay_and_apply.py -v $TEST_IP_PRIMARY snmp/simple_snmp.edw
./replay_and_apply.py -v $TEST_IP_SECONDARY snmp/simple_snmp.edw

./network/replay_net.py $TEST_IP_PRIMARY setup_ha_primary.edw
./network/replay_net.py $TEST_IP_SECONDARY setup_ha_secondary.edw

../replay/replay.py -v $TEST_IP_PRIMARY setup_ha_join.edw

