#!/usr/bin/python

from time import sleep
from nucentral.client.nucentral_client_base import NuCentralClientBase

def config(ip, service):
    client = NuCentralClientBase(host=ip)
    client.call('session', 'authenticate', 'admin', 'admin')
    result = client.call('config', service)
    client.logout()
    return result

if __name__ == '__main__':
    """
    wait end of replication from primary conf. to secondary conf.
    wait while 2 minutes max.
    """
    from optparse import OptionParser
    parser = OptionParser(usage="Usage: %prog primary_ip secondary_ip")
    (options, args) = parser.parse_args()
    if len(args) < 2:
        parser.error("Please specify primary and secondary ip.")

    primary = args[0]
    secondary = args[1]

    # wait 2 minutes max
    for i in range(24):
        p_seq = config(primary, 'getConfigSequenceNumber')
        s_seq = config(secondary, 'getConfigSequenceNumber')
        if p_seq == s_seq:
            print "Synchronization successful", p_seq
            break
        else:
            print "Synchronization unsuccessful:", p_seq, s_seq
            print "Wait 5 sec"
            sleep(5)

    assert p_seq == s_seq
    assert config(primary, 'state') == 'Idle'
    assert config(secondary, 'state') == 'Idle'

