#!/usr/bin/python
# -*- coding: utf-8 -*-

"""
Copyright (C) 2009-2011 EdenWall Technologies

License: All rights reserved.
"""

from __future__ import with_statement
import sys

from getpass import getpass
from nucentral.client.nucentral_client_base import NuCentralClientBase
from nucentral.client.error import NuCentralError
from nucentral.common.error import exceptionAsUnicode

def modify_conf(client, options):
    pass

def authenticate(client, options):
    if not options.username:
        options.username = raw_input("Username: ")
    if options.password is None:
        options.password = getpass("Password for user %s: " %
                                   options.username)
    try:
        client.authenticate(options.username, options.password)
    except NuCentralError, err:
        print exceptionAsUnicode(err)
        sys.exit(11)

def modify_nuconf_conf(client, options):
    if not client.call("nuconf", "takeWriteRole"):
        print "It seems EAS is used by someone. Please retry when nobody is connected to EdenWall using EAS."
        sys.exit(21)
    modify_conf(client, options)
    print client.call("nuconf", "endUsingWriteRole")

if __name__ == '__main__':
    from optparse import OptionParser
    usage = "Usage: %prog [options] host record_file [record_file...]"
    parser = OptionParser(usage=usage)
    parser.add_option("--host", help='Host name or IP',
                      type="str", default=None)
    parser.add_option("--port", help='Server TCP port',
                      type="int", default=None)
    parser.add_option("-u", "--username", help=
                      "Username used with password for authentication",
                      type="str", default=None)
    parser.add_option("-p", "--password", help=
                      "Password used with username for authentication",
                      type="str", default=None)
    # parser.add_option("--cert", help='PEM certificate to use to connect to nucentral',
    #                   type="str", default=u'')
    # parser.add_option("--key", help='PEM key to use to connect to nucentral',
    #                   type="str", default=u'')
    # parser.add_option("--ca", help='PEM CA to use to verify nucentral certificate',
    #                   type="str", default=u'')
    # parser.add_option("--crl", help='PEM CRL to use to verify nucentral certificate',
    #                   type="str", default=u'')
    # parser.add_option("--no-fqdn-check", help=
    #                   'Disable checking the peers FQDN against its certificate',
    #                   action="store_true", default=False)
    (options, args) = parser.parse_args()
    if args:
        parser.print_help()
        sys.exit(2)
    client = NuCentralClientBase(host=options.host)
    authenticate(client, options)
    modify_nuconf_conf(client, options)
