#!/bin/sh
#
# Developer installation of EdenWall (eg. use symlinks)

# Debian packages to use EdenWall:
#
# python-twisted-web python-pyopenssl python-svn python-m2crypto
# python-ldap python-ipy sudo
# python-pyqt4 python-mysqldb python-adns python-twisted-snmp
# python-pyrrd python-qwt5-qt4

src_dir=..
var_dir=/var/lib/nucentral
share_dir=/usr/share/nucentral

acl_db=$var_dir/acl.db
nupki_db=$var_dir/nupki2/certs.db
nucentral_dir=$src_dir/nucentral

if [ $# -ne 1 ]; then
    echo "usage: $0 dev-directory"
    exit 1
fi
devdir=$1

set -e
set -x

cd $(dirname $0)

# nucentral server
(cd $nucentral_dir && make installdirs) || exit $?
mkdir -p $share_dir/scripts
test -e $acl_db || sqlite3 $acl_db < $nucentral_dir/doc/sql/acl_sqlite_debug.sql

# nuface
(cd $src_dir/nuface3 && make installdirs) || exit $?

# nupki
mkdir -p $var_dir/nupki2/templates
test -e $nupki_db || sqlite3 $nupki_db < $src_dir/nupki/sql/sqlite.sql

# multisite
mkdir -p /var/lib/nucentral/multisite
if [ ! -e /var/lib/nucentral/multisite/multisite_acls.db ]; then
    sqlite3 /var/lib/nucentral/multisite/multisite_acls.db < $src_dir/nucentral-edenwall/doc/acl_sqlite_multisite.sql
fi

# nuconf: license
mkdir -p $var_dir/license/gpg
install -m 0700 -d $var_dir/license/gpg
# FIXME: copy GPG files

./create_link.py $devdir

./disable_broken_components.py

(cd .. && ./makeall.sh) || exit $?

echo "FIXME: Setup the license module (install GPG files, copy a valid license)"
echo "FIXME: Disable license module using: rm /var/lib/nucentral/mods-enabled/license"
