#!/bin/bash
# exit on errors
# set -e

# $1 contains the results directory
# $2 contains the test type 
## Test type can be : "autotests" or "unitests"
# $3 contains .buildbot[_subset]
# $4 contains <project>

source $3
if [ $2 == "autotests" ]
then
    tests_list=$autotests_list
    export PYTHONPATH=$PYTHONPATH:/root/autotests
elif [ $2 == "unitests" ]
then
    setup
    tests_list=$unitests_list
    export PYTHONPATH=$PWD:../nuface3:../nucentral-multisite/qt:../nucentral-admin:../nupki:../nulog3:../nuconf:../nucentral:../nucentral-edenwall:$DIR
    trap teardown INT TERM EXIT
fi

if [ "$(echo "$tests_list" | grep -v '^#\|^$')" == "" ]
then
	echo 0 > $1/$4.xit
	exit 0
fi

py.test $(echo "$tests_list" | grep -v '^#\|^$')
EXITCODE=$?

echo $EXITCODE > $1/$4.xit

exit "$EXITCODE"
