from templateTest import Test

EXPECTED_TABS = [
    'Summary',
    'System',
    'Services',
    'EAS Users Management',
    'Firewall',
    'Logs',
    'PKI',
    'Graphs',
    'DPI'
]

class TestEasTabs(Test):
    def test_we_have_all_tabs(self):
        """
            Here we test we have all tabs.
        """
        # Fetch all the tab names
        tab_names = []
        n_tabs = self.window.tabWidget.count()
        for item in range(n_tabs):
            tab_names.append(str(self.window.tabWidget.tabText(item)))

        # Do we have the correct number of tabs ?
        error = "we have %s tabs, we should have 7 or 9" % n_tabs
        assert n_tabs == 9 or n_tabs == 7, error

        # Are all the tabs enabled ?
        for item in range(n_tabs):
            if item > 7:
            # DPI and Graphs are disabled for now
                continue
            assert self.window.tabWidget.widget(item).isEnabled(), \
                    "The tab %s is not activated" % tab_names[item]

        # Print some debug
        print "Found tabs :"
        print tab_names
        print "Expected tabs :"
        print EXPECTED_TABS[:n_tabs]

        # Check that the tabs are correctly placed and written
        for tab in range(n_tabs):
            error = "tab %s is not at its correct position or is not " \
                "correctly written : %s" % (tab_names[tab], EXPECTED_TABS[tab])
            assert tab_names[tab] == EXPECTED_TABS[tab],  error

if __name__ == "__main__":
    my_test = TestEasTabs()
    my_test.setup_class()
    my_test.test_we_have_all_tabs()
    my_test.teardown_class()
