from templateTest import Test

SYSTEM_EXPECTED_PAGES = [
    "<class 'nuconf.client.system.tools.tools.ToolsFrontend'>",
    "<class 'nuconf.client.system.Update.Update'>",
    "<class 'nuconf.client.system.license.license.LicenseFrontend'>",
    "<class 'nuconf.client.system.syslog_export.syslog_export.SyslogExportFrontend'>",
    "<class 'nuconf.client.system.httpout.httpout.HttpOutFrontend'>",
    "<class 'nuconf.client.system.ntp.ntp.NtpFrontend'>",
    "<class 'nuconf.client.system.resolv.resolv_panel.ResolvFrontend'>",
    "<class 'nuconf.client.system.ha.config.HAConfigFrontend'>",
    "<class 'nuconf.client.system.contact.mail.ContactFrontend'>",
    "<class 'nuconf.client.system.network.routes_panel.RoutesFrontend'>",
    "<class 'nuconf.client.system.network.ifaces_panel.IfacesFrontend'>",
    "<class 'nuconf.client.nuauth.NuauthFrontEnd'>"
]

SERVICES_EXPECTED_PAGES = [
    "<class 'nuconf.client.services.snmpd.snmpd.SnmpdFrontend'>",
    "<class 'nuconf.client.services.roadwarrior.roadwarrior.RoadWarriorFrontend'>",
    "<class 'nuconf.client.services.site2site.site2site.Site2SiteFrontend'>",
    "<class 'nuconf.client.services.mail.mail.MailServicesFrontend'>",
    "<class 'nuconf.client.services.proxy.proxy.ProxyFrontend'>",
    "<class 'nuconf.client.services.ids_ips.ids_ips.IdsIpsFrontend'>",
    "<class 'nuconf.client.services.dhcp.dhcp.DhcpFrontend'>",
    "<class 'nuconf.client.services.authentication.authent.AuthenticationFrontend'>",
    "<class 'nuconf.client.services.access.access.AccessFrontend'>",
    "<class 'nuconf.client.services.status_page.StatusPage'>",
]


class TestNuconfPages(Test):
    def _check_expected_pages(self, index, expected_pages):
        """
            Checks all the pages in a QStackedWidget against a list of pages.
        """
        # Choose the tab
        self.window.tabWidget.setCurrentIndex(index)
        system = self.window.tabWidget.currentWidget()
        items = system.main_stack.children()

        # List all the pages in this tab
        found_pages = []
        for item in items:
            if str(type(item)) != "<class 'PyQt4.QtGui.QStackedLayout'>":
                found_pages.append(str(type(item)))

        # Compare the classes of the pages to the expected classes
        for page in expected_pages:
            assert page in found_pages, "%s is not visible" % page

    def test_we_have_all_system_pages(self):
        """
            Here we test we have all pages on the System tab
        """
        self._check_expected_pages(1, SYSTEM_EXPECTED_PAGES)

    def test_we_have_all_services_pages(self):
        """
            Here we test we have all pages on the Services tab
        """
        self._check_expected_pages(2, SERVICES_EXPECTED_PAGES)

if __name__ == "__main__":
    my_test = TestNuconfPages()
    my_test.setup_class()
    my_test.test_we_have_all_system_pages()
    my_test.test_we_have_all_services_pages()
    my_test.teardown_class()
